# A type of -*- python -*- file
import numpy
cimport numpy

cdef extern from "mprans/RANS3PF.h" namespace "proteus":
    cdef cppclass cppRANS3PF_base:
        void calculateResidual(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               double PSTAB,
                               int * mesh_l2g,
                               double * dV_ref,
                               int nDOF_per_element_pressure,
                               double * p_trial_ref,
                               double * p_grad_trial_ref,
                               double * p_test_ref,
                               double * p_grad_test_ref,
                               double * q_p,
                               double * q_grad_p,
                               double * ebqe_p,
                               double * ebqe_grad_p,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_hess_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * p_trial_trace_ref,
                               double * p_grad_trial_trace_ref,
                               double * p_test_trace_ref,
                               double * p_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double eb_adjoint_sigma,
                               double * elementDiameter,
                               double * nodeDiametersArray,
                               double hFactor,
                               int nElements_global,
                               int nElements_owned,
                               int nElementBoundaries_owned,
                               int nNodes_owned,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double epsFact_rho,
                               double epsFact_mu,
                               double sigma,
                               double rho_0,
                               double nu_0,
                               double rho_1,
                               double nu_1,
                               double smagorinskyConstant,
                               int turbulenceClosureModel,
                               double Ct_sge,
                               double Cd_sge,
                               double C_dc,
                               double C_b,
                               # VRANS start
                               double * eps_solid,
                               double * ebq_global_phi_solid,
                               double * ebq_global_grad_phi_solid,
                               double * ebq_particle_velocity_solid,
                               double* phi_solid_nodes,
                               double * phi_solid,
                               double * q_velocity_solid,
                               double * q_vos,
                               double * q_dvos_dt,
                               double * q_grad_vos,
                               double * q_dragAlpha,
                               double * q_dragBeta,
                               double * q_mass_source,
                               double * q_turb_var_0,
                               double * q_turb_var_1,
                               double * q_turb_var_grad_0,
                               double * q_eddy_viscosity,
                               # VRANS end
                               int * p_l2g,
                               int * vel_l2g,
                               double * p_dof,
                               double * u_dof,
                               double * v_dof,
                               double * w_dof,
                               double * u_dof_old,
                               double * v_dof_old,
                               double * w_dof_old,
                               double * u_dof_old_old,
                               double * v_dof_old_old,
                               double * w_dof_old_old,
                               double * g,
                               double useVF,
                               double * vf,
                               double * phi,
                               double * normal_phi,
                               double * kappa_phi,
                               double * q_mom_u_acc,
                               double * q_mom_v_acc,
                               double * q_mom_w_acc,
                               double * q_mass_adv,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_mom_w_acc_beta_bdf,
                               double * q_dV,
                               double * q_dV_last,
                               double * q_velocity_sge,
                               double * ebqe_velocity_star,
                               double * q_cfl,
                               double * q_numDiff_u, double * q_numDiff_v, double * q_numDiff_w,
                               double * q_numDiff_u_last, double * q_numDiff_v_last, double * q_numDiff_w_last,
                               int * sdInfo_u_u_rowptr, int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr, int * sdInfo_u_v_colind,
                               int * sdInfo_u_w_rowptr, int * sdInfo_u_w_colind,
                               int * sdInfo_v_v_rowptr, int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr, int * sdInfo_v_u_colind,
                               int * sdInfo_v_w_rowptr, int * sdInfo_v_w_colind,
                               int * sdInfo_w_w_rowptr, int * sdInfo_w_w_colind,
                               int * sdInfo_w_u_rowptr, int * sdInfo_w_u_colind,
                               int * sdInfo_w_v_rowptr, int * sdInfo_w_v_colind,
                               int offset_p, int offset_u, int offset_v, int offset_w,
                               int stride_p, int stride_u, int stride_v, int stride_w,
                               double * globalResidual,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_vf_ext,
                               double * bc_ebqe_vf_ext,
                               double * ebqe_phi_ext,
                               double * bc_ebqe_phi_ext,
                               double * ebqe_normal_phi_ext,
                               double * ebqe_kappa_phi_ext,
                               # VRANS start
                               double * ebqe_vos_ext,
                               double * ebqe_turb_var_0,
                               double * ebqe_turb_var_1,
                               # VRANS end
                               int * isDOFBoundary_p,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isDOFBoundary_w,
                               int * isAdvectiveFluxBoundary_p,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isAdvectiveFluxBoundary_w,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_w,
                               double * ebqe_bc_p_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_flux_mom_w_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_penalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               double * ebqe_bc_w_ext,
                               double * ebqe_bc_flux_w_diff_ext,
                               double * q_x,
                               double * q_velocity,
                               double * ebqe_velocity,
                               double * q_grad_u,
                               double * q_grad_v,
                               double * q_grad_w,
                               double * q_divU,
                               double * ebqe_grad_u,
                               double * ebqe_grad_v,
                               double * ebqe_grad_w,
                               double * flux,
                               double * elementResidual_p,
                               int * elementFlags,
                               int * boundaryFlags,
                               double * barycenters,
                               double * wettedAreas,
                               double * netForces_p,
                               double * netForces_v,
                               double * netMoments,
                               double * q_rho,
                               double * ebqe_rho,
                               double * q_nu,
                               double * ebqe_nu,
                               int nParticles,
                               double particle_epsFact,
                               double particle_alpha,
                               double particle_beta,
                               double particle_penalty_constant,
                               double * particle_signed_distances,
                               double * particle_signed_distance_normals,
                               double * particle_velocities,
                               double * particle_centroids,
                               double * particle_netForces,
                               double * particle_netMoments,
                               double * particle_surfacArea,
                               double particle_nitsche,
                               int use_ball_as_particle,
                               double* ball_center,
                               double* ball_radius,
                               double* ball_velocity,
                               double* ball_angular_velocity,
                               double * phisError,
                               double * phisErrorNodal,
                               int USE_SUPG,
                               int ARTIFICIAL_VISCOSITY,
                               double cMax,
                               double cE,
                               int MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                               double * forcex,
                               double * forcey,
                               double * forcez,
                               int KILL_PRESSURE_TERM,
                               double dt,
                               double * quantDOFs,
                               int MATERIAL_PARAMETERS_AS_FUNCTION,
                               double * density_as_function,
                               double * dynamic_viscosity_as_function,
                               double * ebqe_density_as_function,
                               double * ebqe_dynamic_viscosity_as_function,
                               double order_polynomial,
                               double* isActiveDOF,
                               int USE_SBM)
        void calculateJacobian(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               double PSTAB,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * p_trial_ref,
                               double * p_grad_trial_ref,
                               double * p_test_ref,
                               double * p_grad_test_ref,
                               double * q_p,
                               double * q_grad_p,
                               double * ebqe_p,
                               double * ebqe_grad_p,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_hess_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * p_trial_trace_ref,
                               double * p_grad_trial_trace_ref,
                               double * p_test_trace_ref,
                               double * p_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double eb_adjoint_sigma,
                               double * elementDiameter,
                               double * nodeDiametersArray,
                               double hFactor,
                               int nElements_global,
                               int nElements_owned,
                               int nElementBoundaries_owned,
                               int nNodes_owned,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double epsFact_rho,
                               double epsFact_mu,
                               double sigma,
                               double rho_0,
                               double nu_0,
                               double rho_1,
                               double nu_1,
                               double smagorinskyConstant,
                               int turbulenceClosureModel,
                               double Ct_sge,
                               double Cd_sge,
                               double C_dg,
                               double C_b,
                               # VRANS start
                               double * eps_solid,
                               double * ebq_global_phi_solid,
                               double * ebq_global_grad_phi_solid,
                               double * ebq_particle_velocity_solid,
                               double * phi_solid_nodes,
                               double * phi_solid,
                               double * q_velocity_solid,
                               double * q_vos,
                               double * q_dvos_dt,
                               double * q_grad_vos,
                               double * q_dragAlpha,
                               double * q_dragBeta,
                               double * q_mass_source,
                               double * q_turb_var_0,
                               double * q_turb_var_1,
                               double * q_turb_var_grad_0,
                               # VRANS end
                               int * p_l2g,
                               int * vel_l2g,
                               double * p_dof, double * u_dof, double * v_dof, double * w_dof,
                               double * g,
                               double useVF,
                               double * vf,
                               double * phi,
                               double * normal_phi,
                               double * kappa_phi,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_mom_w_acc_beta_bdf,
                               double * q_dV,
                               double * q_dV_last,
                               double * q_velocity_sge,
                               double * ebqe_velocity_star,
                               double * q_cfl,
                               double * q_numDiff_u_last, double * q_numDiff_v_last, double * q_numDiff_w_last,
                               int * sdInfo_u_u_rowptr, int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr, int * sdInfo_u_v_colind,
                               int * sdInfo_u_w_rowptr, int * sdInfo_u_w_colind,
                               int * sdInfo_v_v_rowptr, int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr, int * sdInfo_v_u_colind,
                               int * sdInfo_v_w_rowptr, int * sdInfo_v_w_colind,
                               int * sdInfo_w_w_rowptr, int * sdInfo_w_w_colind,
                               int * sdInfo_w_u_rowptr, int * sdInfo_w_u_colind,
                               int * sdInfo_w_v_rowptr, int * sdInfo_w_v_colind,
                               int * csrRowIndeces_p_p, int * csrColumnOffsets_p_p,
                               int * csrRowIndeces_p_u, int * csrColumnOffsets_p_u,
                               int * csrRowIndeces_p_v, int * csrColumnOffsets_p_v,
                               int * csrRowIndeces_p_w, int * csrColumnOffsets_p_w,
                               int * csrRowIndeces_u_p, int * csrColumnOffsets_u_p,
                               int * csrRowIndeces_u_u, int * csrColumnOffsets_u_u,
                               int * csrRowIndeces_u_v, int * csrColumnOffsets_u_v,
                               int * csrRowIndeces_u_w, int * csrColumnOffsets_u_w,
                               int * csrRowIndeces_v_p, int * csrColumnOffsets_v_p,
                               int * csrRowIndeces_v_u, int * csrColumnOffsets_v_u,
                               int * csrRowIndeces_v_v, int * csrColumnOffsets_v_v,
                               int * csrRowIndeces_v_w, int * csrColumnOffsets_v_w,
                               int * csrRowIndeces_w_p, int * csrColumnOffsets_w_p,
                               int * csrRowIndeces_w_u, int * csrColumnOffsets_w_u,
                               int * csrRowIndeces_w_v, int * csrColumnOffsets_w_v,
                               int * csrRowIndeces_w_w, int * csrColumnOffsets_w_w,
                               double * globalJacobian,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_vf_ext,
                               double * bc_ebqe_vf_ext,
                               double * ebqe_phi_ext,
                               double * bc_ebqe_phi_ext,
                               double * ebqe_normal_phi_ext,
                               double * ebqe_kappa_phi_ext,
                               # VRANS start
                               double * ebqe_vos_ext,
                               double * ebqe_turb_var_0,
                               double * ebqe_turb_var_1,
                               # VRANS end
                               int * isDOFBoundary_p,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isDOFBoundary_w,
                               int * isAdvectiveFluxBoundary_p,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isAdvectiveFluxBoundary_w,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_w,
                               double * ebqe_bc_p_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_flux_mom_w_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_penalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               double * ebqe_bc_w_ext,
                               double * ebqe_bc_flux_w_diff_ext,
                               int * csrColumnOffsets_eb_p_p,
                               int * csrColumnOffsets_eb_p_u,
                               int * csrColumnOffsets_eb_p_v,
                               int * csrColumnOffsets_eb_p_w,
                               int * csrColumnOffsets_eb_u_p,
                               int * csrColumnOffsets_eb_u_u,
                               int * csrColumnOffsets_eb_u_v,
                               int * csrColumnOffsets_eb_u_w,
                               int * csrColumnOffsets_eb_v_p,
                               int * csrColumnOffsets_eb_v_u,
                               int * csrColumnOffsets_eb_v_v,
                               int * csrColumnOffsets_eb_v_w,
                               int * csrColumnOffsets_eb_w_p,
                               int * csrColumnOffsets_eb_w_u,
                               int * csrColumnOffsets_eb_w_v,
                               int * csrColumnOffsets_eb_w_w,
                               int * elementFlags,
                               int nParticles,
                               double particle_epsFact,
                               double particle_alpha,
                               double particle_beta,
                               double particle_penalty_constant,
                               double * particle_signed_distances,
                               double * particle_signed_distance_normals,
                               double * particle_velocities,
                               double * particle_centroids,
                               double particle_nitsche,
                               int use_ball_as_particle,
                               double* ball_center,
                               double* ball_radius,
                               double* ball_velocity,
                               double* ball_angular_velocity,
                               int USE_SUPG,
                               int KILL_PRESSURE_TERM,
                               double dt,
                               int MATERIAL_PARAMETERS_AS_FUNCTION,
                               double * density_as_function,
                               double * dynamic_viscosity_as_function,
                               double * ebqe_density_as_function,
                               double * ebqe_dynamic_viscosity_as_function,
                               int USE_SBM)
        void calculateVelocityAverage(int nExteriorElementBoundaries_global,
                                      int * exteriorElementBoundariesArray,
                                      int nInteriorElementBoundaries_global,
                                      int * interiorElementBoundariesArray,
                                      int * elementBoundaryElementsArray,
                                      int * elementBoundaryLocalElementBoundariesArray,
                                      double * mesh_dof,
                                      double * mesh_velocity_dof,
                                      double MOVING_DOMAIN,
                                      int * mesh_l2g,
                                      double * mesh_trial_trace_ref,
                                      double * mesh_grad_trial_trace_ref,
                                      double * normal_ref,
                                      double * boundaryJac_ref,
                                      int * vel_l2g,
                                      double * u_dof,
                                      double * v_dof,
                                      double * w_dof,
                                      double * vos_dof,
                                      double * vel_trial_trace_ref,
                                      double * ebqe_velocity,
                                      double * velocityAverage)

    cppRANS3PF_base * newRANS3PF(int nSpaceIn,
                                 int nQuadraturePoints_elementIn,
                                 int nDOF_mesh_trial_elementIn,
                                 int nDOF_trial_elementIn,
                                 int nDOF_test_elementIn,
                                 int nQuadraturePoints_elementBoundaryIn,
                                 int CompKernelFlag,
                                 double aDarcy,
                                 double betaForch,
                                 double grain,
                                 double packFraction,
                                 double packMargin,
                                 double maxFraction,
                                 double frFraction,
                                 double sigmaC,
                                 double C3e,
                                 double C4e,
                                 double eR,
                                 double fContact,
                                 double mContact,
                                 double nContact,
                                 double angFriction,
                                 double vos_limiter,
                                 double mu_fr_limiter,
                             )


cdef class RANS3PF:
    cdef cppRANS3PF_base * thisptr

    def __cinit__(self,
                  int nSpaceIn,
                  int nQuadraturePoints_elementIn,
                  int nDOF_mesh_trial_elementIn,
                  int nDOF_trial_elementIn,
                  int nDOF_test_elementIn,
                  int nQuadraturePoints_elementBoundaryIn,
                  int CompKernelFlag,
                  double aDarcy,
                  double betaForch,
                  double grain,
                  double packFraction,
                  double packMargin,
                  double maxFraction,
                  double frFraction,
                  double sigmaC,
                  double C3e,
                  double C4e,
                  double eR,
                  double fContact,
                  double mContact,
                  double nContact,
                  double angFriction,
                  double vos_limiter,
                  double mu_fr_limiter,
                  ):
        self.thisptr = newRANS3PF(nSpaceIn,
                                  nQuadraturePoints_elementIn,
                                  nDOF_mesh_trial_elementIn,
                                  nDOF_trial_elementIn,
                                  nDOF_test_elementIn,
                                  nQuadraturePoints_elementBoundaryIn,
                                  CompKernelFlag,
                                  aDarcy,
                                  betaForch,
                                  grain,
                                  packFraction,
                                  packMargin,
                                  maxFraction,
                                  frFraction,
                                  sigmaC,
                                  C3e,
                                  C4e,
                                  eR,
                                  fContact,
                                  mContact,
                                  nContact,
                                  angFriction,
                                  vos_limiter,
                                  mu_fr_limiter,
                                  )

    def __dealloc__(self):
        del self.thisptr

    def calculateResidual(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          double PSTAB,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          int nDOF_per_element_pressure,
                          numpy.ndarray p_trial_ref,
                          numpy.ndarray p_grad_trial_ref,
                          numpy.ndarray p_test_ref,
                          numpy.ndarray p_grad_test_ref,
                          numpy.ndarray q_p,
                          numpy.ndarray q_grad_p,
                          numpy.ndarray ebqe_p,
                          numpy.ndarray ebqe_grad_p,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_hess_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray p_trial_trace_ref,
                          numpy.ndarray p_grad_trial_trace_ref,
                          numpy.ndarray p_test_trace_ref,
                          numpy.ndarray p_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          double eb_adjoint_sigma,
                          numpy.ndarray elementDiameter,
                          numpy.ndarray nodeDiametersArray,
                          double hFactor,
                          int nElements_global,
                          int nElements_owned,
                          int nElementBoundaries_owned,
                          int nNodes_owned,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double epsFact_rho,
                          double epsFact_mu,
                          double sigma,
                          double rho_0,
                          double nu_0,
                          double rho_1,
                          double nu_1,
                          double smagorinskyConstant,
                          int turbulenceClosureModel,
                          double Ct_sge,
                          double Cd_sge,
                          double C_dc,
                          double C_b,
                          # VRANS start
                          numpy.ndarray eps_solid,
                          numpy.ndarray ebq_global_phi_solid,
                          numpy.ndarray ebq_global_grad_phi_solid,
                          numpy.ndarray ebq_particle_velocity_solid,
                          numpy.ndarray phi_solid_nodes,
                          numpy.ndarray phi_solid,
                          numpy.ndarray q_velocity_solid,
                          numpy.ndarray q_vos,
                          numpy.ndarray q_dvos_dt,
                          numpy.ndarray q_grad_vos,
                          numpy.ndarray q_dragAlpha,
                          numpy.ndarray q_dragBeta,
                          numpy.ndarray q_mass_source,
                          numpy.ndarray q_turb_var_0,
                          numpy.ndarray q_turb_var_1,
                          numpy.ndarray q_turb_var_grad_0,
                          numpy.ndarray q_eddy_viscosity,
                          # VRANS end
                          numpy.ndarray p_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray p_dof,
                          numpy.ndarray u_dof,
                          numpy.ndarray v_dof,
                          numpy.ndarray w_dof,
                          numpy.ndarray u_dof_old,
                          numpy.ndarray v_dof_old,
                          numpy.ndarray w_dof_old,
                          numpy.ndarray u_dof_old_old,
                          numpy.ndarray v_dof_old_old,
                          numpy.ndarray w_dof_old_old,
                          numpy.ndarray g,
                          double useVF,
                          numpy.ndarray vf,
                          numpy.ndarray phi,
                          numpy.ndarray normal_phi,
                          numpy.ndarray kappa_phi,
                          numpy.ndarray q_mom_u_acc,
                          numpy.ndarray q_mom_v_acc,
                          numpy.ndarray q_mom_w_acc,
                          numpy.ndarray q_mass_adv,
                          numpy.ndarray q_mom_u_acc_beta_bdf, numpy.ndarray q_mom_v_acc_beta_bdf, numpy.ndarray q_mom_w_acc_beta_bdf,
                          numpy.ndarray q_dV,
                          numpy.ndarray q_dV_last,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray ebqe_velocity_star,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_u, numpy.ndarray q_numDiff_v, numpy.ndarray q_numDiff_w,
                          numpy.ndarray q_numDiff_u_last, numpy.ndarray q_numDiff_v_last, numpy.ndarray q_numDiff_w_last,
                          numpy.ndarray sdInfo_u_u_rowptr, numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr, numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_u_w_rowptr, numpy.ndarray sdInfo_u_w_colind,
                          numpy.ndarray sdInfo_v_v_rowptr, numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr, numpy.ndarray sdInfo_v_u_colind,
                          numpy.ndarray sdInfo_v_w_rowptr, numpy.ndarray sdInfo_v_w_colind,
                          numpy.ndarray sdInfo_w_w_rowptr, numpy.ndarray sdInfo_w_w_colind,
                          numpy.ndarray sdInfo_w_u_rowptr, numpy.ndarray sdInfo_w_u_colind,
                          numpy.ndarray sdInfo_w_v_rowptr, numpy.ndarray sdInfo_w_v_colind,
                          int offset_p, int offset_u, int offset_v, int offset_w,
                          int stride_p, int stride_u, int stride_v, int stride_w,
                          numpy.ndarray globalResidual,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_vf_ext,
                          numpy.ndarray bc_ebqe_vf_ext,
                          numpy.ndarray ebqe_phi_ext,
                          numpy.ndarray bc_ebqe_phi_ext,
                          numpy.ndarray ebqe_normal_phi_ext,
                          numpy.ndarray ebqe_kappa_phi_ext,
                          # VRANS start
                          numpy.ndarray ebqe_vos_ext,
                          numpy.ndarray ebqe_turb_var_0,
                          numpy.ndarray ebqe_turb_var_1,
                          # VRANS end
                          numpy.ndarray isDOFBoundary_p,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isDOFBoundary_w,
                          numpy.ndarray isAdvectiveFluxBoundary_p,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_w,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_w,
                          numpy.ndarray ebqe_bc_p_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_w_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_penalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray ebqe_bc_w_ext,
                          numpy.ndarray ebqe_bc_flux_w_diff_ext,
                          numpy.ndarray q_x,
                          numpy.ndarray q_velocity,
                          numpy.ndarray ebqe_velocity,
                          numpy.ndarray q_grad_u,
                          numpy.ndarray q_grad_v,
                          numpy.ndarray q_grad_w,
                          numpy.ndarray q_divU,
                          numpy.ndarray ebqe_grad_u,
                          numpy.ndarray ebqe_grad_v,
                          numpy.ndarray ebqe_grad_w,
                          numpy.ndarray flux,
                          numpy.ndarray elementResidual_p,
                          numpy.ndarray elementFlags,
                          numpy.ndarray boundaryFlags,
                          numpy.ndarray barycenters,
                          numpy.ndarray wettedAreas,
                          numpy.ndarray netForces_p,
                          numpy.ndarray netForces_v,
                          numpy.ndarray netMoments,
                          numpy.ndarray q_rho,
                          numpy.ndarray ebqe_rho,
                          numpy.ndarray q_nu,
                          numpy.ndarray ebqe_nu,
                          int nParticles,
                          double particle_epsFact,
                          double particle_alpha,
                          double particle_beta,
                          double particle_penalty_constant,
                          numpy.ndarray particle_signed_distances,
                          numpy.ndarray particle_signed_distance_normals,
                          numpy.ndarray particle_velocities,
                          numpy.ndarray particle_centroids,
                          numpy.ndarray particle_netForces,
                          numpy.ndarray particle_netMoments,
                          numpy.ndarray particle_surfaceArea,
                          double particle_nitsche,
                          int use_ball_as_particle,
                          numpy.ndarray ball_center,
                          numpy.ndarray ball_radius,
                          numpy.ndarray ball_velocity,
                          numpy.ndarray ball_angular_velocity,
                          numpy.ndarray phisError,
                          numpy.ndarray phisErrorNodal,
                          int USE_SUPG,
                          int ARTIFICIAL_VISCOSITY,
                          double cMax,
                          double cE,
                          int MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                          numpy.ndarray forcex,
                          numpy.ndarray forcey,
                          numpy.ndarray forcez,
                          int KILL_PRESSURE_TERM,
                          double dt,
                          numpy.ndarray quantDOFs,
                          int MATERIAL_PARAMETERS_AS_FUNCTION,
                          numpy.ndarray density_as_function,
                          numpy.ndarray dynamic_viscosity_as_function,
                          numpy.ndarray ebqe_density_as_function,
                          numpy.ndarray ebqe_dynamic_viscosity_as_function,
                          double order_polynomial,
                          numpy.ndarray isActiveDOF,
                          int USE_SBM):
        self.thisptr.calculateResidual(< double * > mesh_trial_ref.data,
                                       < double * > mesh_grad_trial_ref.data,
                                       < double * > mesh_dof.data,
                                       < double * > mesh_velocity_dof.data,
                                       MOVING_DOMAIN,
                                       PSTAB,
                                       < int * > mesh_l2g.data,
                                       < double * > dV_ref.data,
                                       nDOF_per_element_pressure,
                                       < double * > p_trial_ref.data,
                                       < double * > p_grad_trial_ref.data,
                                       < double * > p_test_ref.data,
                                       < double * > p_grad_test_ref.data,
                                       < double * > q_p.data,
                                       < double * > q_grad_p.data,
                                       < double * > ebqe_p.data,
                                       < double * > ebqe_grad_p.data,
                                       < double * > vel_trial_ref.data,
                                       < double * > vel_grad_trial_ref.data,
                                       < double * > vel_hess_trial_ref.data,
                                       < double * > vel_test_ref.data,
                                       < double * > vel_grad_test_ref.data,
                                       < double * > mesh_trial_trace_ref.data,
                                       < double * > mesh_grad_trial_trace_ref.data,
                                       < double * > dS_ref.data,
                                       < double * > p_trial_trace_ref.data,
                                       < double * > p_grad_trial_trace_ref.data,
                                       < double * > p_test_trace_ref.data,
                                       < double * > p_grad_test_trace_ref.data,
                                       < double * > vel_trial_trace_ref.data,
                                       < double * > vel_grad_trial_trace_ref.data,
                                       < double * > vel_test_trace_ref.data,
                                       < double * > vel_grad_test_trace_ref.data,
                                       < double * > normal_ref.data,
                                       < double * > boundaryJac_ref.data,
                                       eb_adjoint_sigma,
                                       < double * > elementDiameter.data,
                                       < double * > nodeDiametersArray.data,
                                       hFactor,
                                       nElements_global,
                                       nElements_owned,
                                       nElementBoundaries_owned,
                                       nNodes_owned,
                                       useRBLES,
                                       useMetrics,
                                       alphaBDF,
                                       epsFact_rho,
                                       epsFact_mu,
                                       sigma,
                                       rho_0,
                                       nu_0,
                                       rho_1,
                                       nu_1,
                                       smagorinskyConstant,
                                       turbulenceClosureModel,
                                       Ct_sge,
                                       Cd_sge,
                                       C_dc,
                                       C_b,
                                       < double* > eps_solid.data,
                                       < double* > ebq_global_phi_solid.data,
                                       < double* > ebq_global_grad_phi_solid.data,
                                       < double* > ebq_particle_velocity_solid.data,
                                       < double* > phi_solid_nodes.data,
                                       < double * > phi_solid.data,
                                       < double * > q_velocity_solid.data,
                                       < double * > q_vos.data,
                                       < double * > q_dvos_dt.data,
                                       < double * > q_grad_vos.data,
                                       < double * > q_dragAlpha.data,
                                       < double * > q_dragBeta.data,
                                       < double * > q_mass_source.data,
                                       < double * > q_turb_var_0.data,
                                       < double * > q_turb_var_1.data,
                                       < double * > q_turb_var_grad_0.data,
                                       < double * > q_eddy_viscosity.data,
                                       < int * > p_l2g.data,
                                       < int * > vel_l2g.data,
                                       < double * > p_dof.data,
                                       < double * > u_dof.data,
                                       < double * > v_dof.data,
                                       < double * > w_dof.data,
                                       < double * > u_dof_old.data,
                                       < double * > v_dof_old.data,
                                       < double * > w_dof_old.data,
                                       < double * > u_dof_old_old.data,
                                       < double * > v_dof_old_old.data,
                                       < double * > w_dof_old_old.data,
                                       < double * > g.data,
                                       useVF,
                                       < double * > vf.data,
                                       < double * > phi.data,
                                       < double * > normal_phi.data,
                                       < double * > kappa_phi.data,
                                       < double * > q_mom_u_acc.data,
                                       < double * > q_mom_v_acc.data,
                                       < double * > q_mom_w_acc.data,
                                       < double * > q_mass_adv.data,
                                       < double * > q_mom_u_acc_beta_bdf.data, < double * > q_mom_v_acc_beta_bdf.data, < double * > q_mom_w_acc_beta_bdf.data,
                                       < double * > q_dV.data,
                                       < double * > q_dV_last.data,
                                       < double * > q_velocity_sge.data,
                                       < double * > ebqe_velocity_star.data,
                                       < double * > q_cfl.data,
                                       < double * > q_numDiff_u.data, < double * > q_numDiff_v.data, < double * > q_numDiff_w.data,
                                       < double * > q_numDiff_u_last.data, < double * > q_numDiff_v_last.data, < double * > q_numDiff_w_last.data,
                                       < int * > sdInfo_u_u_rowptr.data, < int * > sdInfo_u_u_colind.data,
                                       < int * > sdInfo_u_v_rowptr.data, < int * > sdInfo_u_v_colind.data,
                                       < int * > sdInfo_u_w_rowptr.data, < int * > sdInfo_u_w_colind.data,
                                       < int * > sdInfo_v_v_rowptr.data, < int * > sdInfo_v_v_colind.data,
                                       < int * > sdInfo_v_u_rowptr.data, < int * > sdInfo_v_u_colind.data,
                                       < int * > sdInfo_v_w_rowptr.data, < int * > sdInfo_v_w_colind.data,
                                       < int * > sdInfo_w_w_rowptr.data, < int * > sdInfo_w_w_colind.data,
                                       < int * > sdInfo_w_u_rowptr.data, < int * > sdInfo_w_u_colind.data,
                                       < int * > sdInfo_w_v_rowptr.data, < int * > sdInfo_w_v_colind.data,
                                       offset_p, offset_u, offset_v, offset_w,
                                       stride_p, stride_u, stride_v, stride_w,
                                       < double * > globalResidual.data,
                                       nExteriorElementBoundaries_global,
                                       < int * > exteriorElementBoundariesArray.data,
                                       < int * > elementBoundariesArray.data,
                                       < int * > elementBoundaryElementsArray.data,
                                       < int * > elementBoundaryLocalElementBoundariesArray.data,
                                       < double * > ebqe_vf_ext.data,
                                       < double * > bc_ebqe_vf_ext.data,
                                       < double * > ebqe_phi_ext.data,
                                       < double * > bc_ebqe_phi_ext.data,
                                       < double * > ebqe_normal_phi_ext.data,
                                       < double * > ebqe_kappa_phi_ext.data,
                                       < double * > ebqe_vos_ext.data,
                                       < double * > ebqe_turb_var_0.data,
                                       < double * > ebqe_turb_var_1.data,
                                       < int * > isDOFBoundary_p.data,
                                       < int * > isDOFBoundary_u.data,
                                       < int * > isDOFBoundary_v.data,
                                       < int * > isDOFBoundary_w.data,
                                       < int * > isAdvectiveFluxBoundary_p.data,
                                       < int * > isAdvectiveFluxBoundary_u.data,
                                       < int * > isAdvectiveFluxBoundary_v.data,
                                       < int * > isAdvectiveFluxBoundary_w.data,
                                       < int * > isDiffusiveFluxBoundary_u.data,
                                       < int * > isDiffusiveFluxBoundary_v.data,
                                       < int * > isDiffusiveFluxBoundary_w.data,
                                       < double * > ebqe_bc_p_ext.data,
                                       < double * > ebqe_bc_flux_mass_ext.data,
                                       < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                       < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                       < double * > ebqe_bc_flux_mom_w_adv_ext.data,
                                       < double * > ebqe_bc_u_ext.data,
                                       < double * > ebqe_bc_flux_u_diff_ext.data,
                                       < double * > ebqe_penalty_ext.data,
                                       < double * > ebqe_bc_v_ext.data,
                                       < double * > ebqe_bc_flux_v_diff_ext.data,
                                       < double * > ebqe_bc_w_ext.data,
                                       < double * > ebqe_bc_flux_w_diff_ext.data,
                                       < double * > q_x.data,
                                       < double * > q_velocity.data,
                                       < double * > ebqe_velocity.data,
                                       < double * > q_grad_u.data,
                                       < double * > q_grad_v.data,
                                       < double * > q_grad_w.data,
                                       < double * > q_divU.data,
                                       < double * > ebqe_grad_u.data,
                                       < double * > ebqe_grad_v.data,
                                       < double * > ebqe_grad_w.data,
                                       < double * > flux.data,
                                       < double * > elementResidual_p.data,
                                       < int * > elementFlags.data,
                                       < int * > boundaryFlags.data,
                                       < double * > barycenters.data,
                                       < double * > wettedAreas.data,
                                       < double * > netForces_p.data,
                                       < double * > netForces_v.data,
                                       < double * > netMoments.data,
                                       < double * > q_rho.data,
                                       < double * > ebqe_rho.data,
                                       < double * > q_nu.data,
                                       < double * > ebqe_nu.data,
                                       nParticles,
                                       particle_epsFact,
                                       particle_alpha,
                                       particle_beta,
                                       particle_penalty_constant,
                                       < double * > particle_signed_distances.data,
                                       < double * > particle_signed_distance_normals.data,
                                       < double * > particle_velocities.data,
                                       < double * > particle_centroids.data,
                                       < double * > particle_netForces.data,
                                       < double * > particle_netMoments.data,
                                       < double * > particle_surfaceArea.data,
                                       particle_nitsche,
                                       use_ball_as_particle,
                                       < double * > ball_center.data,
                                       < double * > ball_radius.data,
                                       < double * > ball_velocity.data,
                                       < double * > ball_angular_velocity.data,
                                       < double * > phisError.data,
                                       < double * > phisErrorNodal.data,
                                       USE_SUPG,
                                       ARTIFICIAL_VISCOSITY,
                                       cMax,
                                       cE,
                                       MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                                       < double * > forcex.data,
                                       < double * > forcey.data,
                                       < double * > forcez.data,
                                       KILL_PRESSURE_TERM,
                                       dt,
                                       < double * > quantDOFs.data,
                                       MATERIAL_PARAMETERS_AS_FUNCTION,
                                       < double * > density_as_function.data,
                                       < double * > dynamic_viscosity_as_function.data,
                                       < double * > ebqe_density_as_function.data,
                                       < double * > ebqe_dynamic_viscosity_as_function.data,
                                       order_polynomial,
                                       < double *> isActiveDOF.data,
                                       USE_SBM)
    def calculateJacobian(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          double PSTAB,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray p_trial_ref,
                          numpy.ndarray p_grad_trial_ref,
                          numpy.ndarray p_test_ref,
                          numpy.ndarray p_grad_test_ref,
                          numpy.ndarray q_p,
                          numpy.ndarray q_grad_p,
                          numpy.ndarray ebqe_p,
                          numpy.ndarray ebqe_grad_p,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_hess_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray p_trial_trace_ref,
                          numpy.ndarray p_grad_trial_trace_ref,
                          numpy.ndarray p_test_trace_ref,
                          numpy.ndarray p_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          double eb_adjoint_sigma,
                          numpy.ndarray elementDiameter,
                          numpy.ndarray nodeDiametersArray,
                          double hFactor,
                          int nElements_global,
                          int nElements_owned,
                          int nElementBoundaries_owned,
                          int nNodes_owned,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double epsFact_rho,
                          double epsFact_mu,
                          double sigma,
                          double rho_0,
                          double nu_0,
                          double rho_1,
                          double nu_1,
                          double smagorinskyConstant,
                          int turbulenceClosureModel,
                          double Ct_sge,
                          double Cd_sge,
                          double C_dg,
                          double C_b,
                          # VRANS start
                          numpy.ndarray eps_solid,
                          numpy.ndarray ebq_global_phi_solid,
                          numpy.ndarray ebq_global_grad_phi_solid,
                          numpy.ndarray ebq_particle_velocity_solid,
                          numpy.ndarray phi_solid_nodes,
                          numpy.ndarray phi_solid,
                          numpy.ndarray q_velocity_solid,
                          numpy.ndarray q_vos,
                          numpy.ndarray q_dvos_dt,
                          numpy.ndarray q_grad_vos,
                          numpy.ndarray q_dragAlpha,
                          numpy.ndarray q_dragBeta,
                          numpy.ndarray q_mass_source,
                          numpy.ndarray q_turb_var_0,
                          numpy.ndarray q_turb_var_1,
                          numpy.ndarray q_turb_var_grad_0,
                          # VRANS end
                          numpy.ndarray p_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray p_dof, numpy.ndarray u_dof, numpy.ndarray v_dof, numpy.ndarray w_dof,
                          numpy.ndarray g,
                          double useVF,
                          numpy.ndarray vf,
                          numpy.ndarray phi,
                          numpy.ndarray normal_phi,
                          numpy.ndarray kappa_phi,
                          numpy.ndarray q_mom_u_acc_beta_bdf, numpy.ndarray q_mom_v_acc_beta_bdf, numpy.ndarray q_mom_w_acc_beta_bdf,
                          numpy.ndarray q_dV,
                          numpy.ndarray q_dV_last,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray ebqe_velocity_star,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_u_last, numpy.ndarray q_numDiff_v_last, numpy.ndarray q_numDiff_w_last,
                          numpy.ndarray sdInfo_u_u_rowptr, numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr, numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_u_w_rowptr, numpy.ndarray sdInfo_u_w_colind,
                          numpy.ndarray sdInfo_v_v_rowptr, numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr, numpy.ndarray sdInfo_v_u_colind,
                          numpy.ndarray sdInfo_v_w_rowptr, numpy.ndarray sdInfo_v_w_colind,
                          numpy.ndarray sdInfo_w_w_rowptr, numpy.ndarray sdInfo_w_w_colind,
                          numpy.ndarray sdInfo_w_u_rowptr, numpy.ndarray sdInfo_w_u_colind,
                          numpy.ndarray sdInfo_w_v_rowptr, numpy.ndarray sdInfo_w_v_colind,
                          numpy.ndarray csrRowIndeces_p_p, numpy.ndarray csrColumnOffsets_p_p,
                          numpy.ndarray csrRowIndeces_p_u, numpy.ndarray csrColumnOffsets_p_u,
                          numpy.ndarray csrRowIndeces_p_v, numpy.ndarray csrColumnOffsets_p_v,
                          numpy.ndarray csrRowIndeces_p_w, numpy.ndarray csrColumnOffsets_p_w,
                          numpy.ndarray csrRowIndeces_u_p, numpy.ndarray csrColumnOffsets_u_p,
                          numpy.ndarray csrRowIndeces_u_u, numpy.ndarray csrColumnOffsets_u_u,
                          numpy.ndarray csrRowIndeces_u_v, numpy.ndarray csrColumnOffsets_u_v,
                          numpy.ndarray csrRowIndeces_u_w, numpy.ndarray csrColumnOffsets_u_w,
                          numpy.ndarray csrRowIndeces_v_p, numpy.ndarray csrColumnOffsets_v_p,
                          numpy.ndarray csrRowIndeces_v_u, numpy.ndarray csrColumnOffsets_v_u,
                          numpy.ndarray csrRowIndeces_v_v, numpy.ndarray csrColumnOffsets_v_v,
                          numpy.ndarray csrRowIndeces_v_w, numpy.ndarray csrColumnOffsets_v_w,
                          numpy.ndarray csrRowIndeces_w_p, numpy.ndarray csrColumnOffsets_w_p,
                          numpy.ndarray csrRowIndeces_w_u, numpy.ndarray csrColumnOffsets_w_u,
                          numpy.ndarray csrRowIndeces_w_v, numpy.ndarray csrColumnOffsets_w_v,
                          numpy.ndarray csrRowIndeces_w_w, numpy.ndarray csrColumnOffsets_w_w,
                          globalJacobian,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_vf_ext,
                          numpy.ndarray bc_ebqe_vf_ext,
                          numpy.ndarray ebqe_phi_ext,
                          numpy.ndarray bc_ebqe_phi_ext,
                          numpy.ndarray ebqe_normal_phi_ext,
                          numpy.ndarray ebqe_kappa_phi_ext,
                          # VRANS start
                          numpy.ndarray ebqe_vos_ext,
                          numpy.ndarray ebqe_turb_var_0,
                          numpy.ndarray ebqe_turb_var_1,
                          # VRANS end
                          numpy.ndarray isDOFBoundary_p,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isDOFBoundary_w,
                          numpy.ndarray isAdvectiveFluxBoundary_p,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_w,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_w,
                          numpy.ndarray ebqe_bc_p_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_w_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_penalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray ebqe_bc_w_ext,
                          numpy.ndarray ebqe_bc_flux_w_diff_ext,
                          numpy.ndarray csrColumnOffsets_eb_p_p,
                          numpy.ndarray csrColumnOffsets_eb_p_u,
                          numpy.ndarray csrColumnOffsets_eb_p_v,
                          numpy.ndarray csrColumnOffsets_eb_p_w,
                          numpy.ndarray csrColumnOffsets_eb_u_p,
                          numpy.ndarray csrColumnOffsets_eb_u_u,
                          numpy.ndarray csrColumnOffsets_eb_u_v,
                          numpy.ndarray csrColumnOffsets_eb_u_w,
                          numpy.ndarray csrColumnOffsets_eb_v_p,
                          numpy.ndarray csrColumnOffsets_eb_v_u,
                          numpy.ndarray csrColumnOffsets_eb_v_v,
                          numpy.ndarray csrColumnOffsets_eb_v_w,
                          numpy.ndarray csrColumnOffsets_eb_w_p,
                          numpy.ndarray csrColumnOffsets_eb_w_u,
                          numpy.ndarray csrColumnOffsets_eb_w_v,
                          numpy.ndarray csrColumnOffsets_eb_w_w,
                          numpy.ndarray elementFlags,
                          int nParticles,
                          double particle_epsFact,
                          double particle_alpha,
                          double particle_beta,
                          double particle_penalty_constant,
                          numpy.ndarray particle_signed_distances,
                          numpy.ndarray particle_signed_distance_normals,
                          numpy.ndarray particle_velocities,
                          numpy.ndarray particle_centroids,
                          double particle_nitsche,
                          int use_ball_as_particle,
                          numpy.ndarray ball_center,
                          numpy.ndarray ball_radius,
                          numpy.ndarray ball_velocity,
                          numpy.ndarray ball_angular_velocity,
                          int USE_SUPG,
                          int KILL_PRESSURE_TERM,
                          double dt,
                          int MATERIAL_PARAMETERS_AS_FUNCTION,
                          numpy.ndarray density_as_function,
                          numpy.ndarray dynamic_viscosity_as_function,
                          numpy.ndarray ebqe_density_as_function,
                          numpy.ndarray ebqe_dynamic_viscosity_as_function,
                          int USE_SBM):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateJacobian(< double * > mesh_trial_ref.data,
                                        < double * > mesh_grad_trial_ref.data,
                                        < double * > mesh_dof.data,
                                        < double * > mesh_velocity_dof.data,
                                        MOVING_DOMAIN,
                                        PSTAB,
                                        < int * > mesh_l2g.data,
                                        < double * > dV_ref.data,
                                        < double * > p_trial_ref.data,
                                        < double * > p_grad_trial_ref.data,
                                        < double * > p_test_ref.data,
                                        < double * > p_grad_test_ref.data,
                                        < double * > q_p.data,
                                        < double * > q_grad_p.data,
                                        < double * > ebqe_p.data,
                                        < double * > ebqe_grad_p.data,
                                        < double * > vel_trial_ref.data,
                                        < double * > vel_grad_trial_ref.data,
                                        < double * > vel_hess_trial_ref.data,
                                        < double * > vel_test_ref.data,
                                        < double * > vel_grad_test_ref.data,
                                        < double * > mesh_trial_trace_ref.data,
                                        < double * > mesh_grad_trial_trace_ref.data,
                                        < double * > dS_ref.data,
                                        < double * > p_trial_trace_ref.data,
                                        < double * > p_grad_trial_trace_ref.data,
                                        < double * > p_test_trace_ref.data,
                                        < double * > p_grad_test_trace_ref.data,
                                        < double * > vel_trial_trace_ref.data,
                                        < double * > vel_grad_trial_trace_ref.data,
                                        < double * > vel_test_trace_ref.data,
                                        < double * > vel_grad_test_trace_ref.data,
                                        < double * > normal_ref.data,
                                        < double * > boundaryJac_ref.data,
                                        eb_adjoint_sigma,
                                        < double * > elementDiameter.data,
                                        < double * > nodeDiametersArray.data,
                                        hFactor,
                                        nElements_global,
                                        nElements_owned,
                                        nElementBoundaries_owned,
                                        nNodes_owned,
                                        useRBLES,
                                        useMetrics,
                                        alphaBDF,
                                        epsFact_rho,
                                        epsFact_mu,
                                        sigma,
                                        rho_0,
                                        nu_0,
                                        rho_1,
                                        nu_1,
                                        smagorinskyConstant,
                                        turbulenceClosureModel,
                                        Ct_sge,
                                        Cd_sge,
                                        C_dg,
                                        C_b,
                                        < double * > eps_solid.data,
                                        < double* > ebq_global_phi_solid.data,
                                        < double* > ebq_global_grad_phi_solid.data,
                                        < double* > ebq_particle_velocity_solid.data,
                                        < double* > phi_solid_nodes.data,
                                        < double * > phi_solid.data,
                                        < double * > q_velocity_solid.data,
                                        < double * > q_vos.data,
                                        < double * > q_dvos_dt.data,
                                       < double * > q_grad_vos.data,
                                        < double * > q_dragAlpha.data,
                                        < double * > q_dragBeta.data,
                                        < double * > q_mass_source.data,
                                        < double * > q_turb_var_0.data,
                                        < double * > q_turb_var_1.data,
                                        < double * > q_turb_var_grad_0.data,
                                        < int * > p_l2g.data,
                                        < int * > vel_l2g.data,
                                        < double * > p_dof.data, < double * > u_dof.data, < double * > v_dof.data, < double * > w_dof.data,
                                        < double * > g.data,
                                        useVF,
                                        < double * > vf.data,
                                        < double * > phi.data,
                                        < double * > normal_phi.data,
                                        < double * > kappa_phi.data,
                                        < double * > q_mom_u_acc_beta_bdf.data, < double * > q_mom_v_acc_beta_bdf.data, < double * > q_mom_w_acc_beta_bdf.data,
                                        < double * > q_dV.data,
                                        < double * > q_dV_last.data,
                                        < double * > q_velocity_sge.data,
                                        < double * > ebqe_velocity_star.data,
                                        < double * > q_cfl.data,
                                        < double * > q_numDiff_u_last.data, < double * > q_numDiff_v_last.data, < double * > q_numDiff_w_last.data,
                                        < int * > sdInfo_u_u_rowptr.data, < int * > sdInfo_u_u_colind.data,
                                        < int * > sdInfo_u_v_rowptr.data, < int * > sdInfo_u_v_colind.data,
                                        < int * > sdInfo_u_w_rowptr.data, < int * > sdInfo_u_w_colind.data,
                                        < int * > sdInfo_v_v_rowptr.data, < int * > sdInfo_v_v_colind.data,
                                        < int * > sdInfo_v_u_rowptr.data, < int * > sdInfo_v_u_colind.data,
                                        < int * > sdInfo_v_w_rowptr.data, < int * > sdInfo_v_w_colind.data,
                                        < int * > sdInfo_w_w_rowptr.data, < int * > sdInfo_w_w_colind.data,
                                        < int * > sdInfo_w_u_rowptr.data, < int * > sdInfo_w_u_colind.data,
                                        < int * > sdInfo_w_v_rowptr.data, < int * > sdInfo_w_v_colind.data,
                                        < int * > csrRowIndeces_p_p.data, < int * > csrColumnOffsets_p_p.data,
                                        < int * > csrRowIndeces_p_u.data, < int * > csrColumnOffsets_p_u.data,
                                        < int * > csrRowIndeces_p_v.data, < int * > csrColumnOffsets_p_v.data,
                                        < int * > csrRowIndeces_p_w.data, < int * > csrColumnOffsets_p_w.data,
                                        < int * > csrRowIndeces_u_p.data, < int * > csrColumnOffsets_u_p.data,
                                        < int * > csrRowIndeces_u_u.data, < int * > csrColumnOffsets_u_u.data,
                                        < int * > csrRowIndeces_u_v.data, < int * > csrColumnOffsets_u_v.data,
                                        < int * > csrRowIndeces_u_w.data, < int * > csrColumnOffsets_u_w.data,
                                        < int * > csrRowIndeces_v_p.data, < int * > csrColumnOffsets_v_p.data,
                                        < int * > csrRowIndeces_v_u.data, < int * > csrColumnOffsets_v_u.data,
                                        < int * > csrRowIndeces_v_v.data, < int * > csrColumnOffsets_v_v.data,
                                        < int * > csrRowIndeces_v_w.data, < int * > csrColumnOffsets_v_w.data,
                                        < int * > csrRowIndeces_w_p.data, < int * > csrColumnOffsets_w_p.data,
                                        < int * > csrRowIndeces_w_u.data, < int * > csrColumnOffsets_w_u.data,
                                        < int * > csrRowIndeces_w_v.data, < int * > csrColumnOffsets_w_v.data,
                                        < int * > csrRowIndeces_w_w.data, < int * > csrColumnOffsets_w_w.data,
                                        < double * > globalJacobian_a.data,
                                        nExteriorElementBoundaries_global,
                                        < int * > exteriorElementBoundariesArray.data,
                                        < int * > elementBoundariesArray.data,
                                        < int * > elementBoundaryElementsArray.data,
                                        < int * > elementBoundaryLocalElementBoundariesArray.data,
                                        < double * > ebqe_vf_ext.data,
                                        < double * > bc_ebqe_vf_ext.data,
                                        < double * > ebqe_phi_ext.data,
                                        < double * > bc_ebqe_phi_ext.data,
                                        < double * > ebqe_normal_phi_ext.data,
                                        < double * > ebqe_kappa_phi_ext.data,
                                        < double * > ebqe_vos_ext.data,
                                        < double * > ebqe_turb_var_0.data,
                                        < double * > ebqe_turb_var_1.data,
                                        < int * > isDOFBoundary_p.data,
                                        < int * > isDOFBoundary_u.data,
                                        < int * > isDOFBoundary_v.data,
                                        < int * > isDOFBoundary_w.data,
                                        < int * > isAdvectiveFluxBoundary_p.data,
                                        < int * > isAdvectiveFluxBoundary_u.data,
                                        < int * > isAdvectiveFluxBoundary_v.data,
                                        < int * > isAdvectiveFluxBoundary_w.data,
                                        < int * > isDiffusiveFluxBoundary_u.data,
                                        < int * > isDiffusiveFluxBoundary_v.data,
                                        < int * > isDiffusiveFluxBoundary_w.data,
                                        < double * > ebqe_bc_p_ext.data,
                                        < double * > ebqe_bc_flux_mass_ext.data,
                                        < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                        < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                        < double * > ebqe_bc_flux_mom_w_adv_ext.data,
                                        < double * > ebqe_bc_u_ext.data,
                                        < double * > ebqe_bc_flux_u_diff_ext.data,
                                        < double * > ebqe_penalty_ext.data,
                                        < double * > ebqe_bc_v_ext.data,
                                        < double * > ebqe_bc_flux_v_diff_ext.data,
                                        < double * > ebqe_bc_w_ext.data,
                                        < double * > ebqe_bc_flux_w_diff_ext.data,
                                        < int * > csrColumnOffsets_eb_p_p.data,
                                        < int * > csrColumnOffsets_eb_p_u.data,
                                        < int * > csrColumnOffsets_eb_p_v.data,
                                        < int * > csrColumnOffsets_eb_p_w.data,
                                        < int * > csrColumnOffsets_eb_u_p.data,
                                        < int * > csrColumnOffsets_eb_u_u.data,
                                        < int * > csrColumnOffsets_eb_u_v.data,
                                        < int * > csrColumnOffsets_eb_u_w.data,
                                        < int * > csrColumnOffsets_eb_v_p.data,
                                        < int * > csrColumnOffsets_eb_v_u.data,
                                        < int * > csrColumnOffsets_eb_v_v.data,
                                        < int * > csrColumnOffsets_eb_v_w.data,
                                        < int * > csrColumnOffsets_eb_w_p.data,
                                        < int * > csrColumnOffsets_eb_w_u.data,
                                        < int * > csrColumnOffsets_eb_w_v.data,
                                        < int * > csrColumnOffsets_eb_w_w.data,
                                        < int * > elementFlags.data,
                                        nParticles,
                                        particle_epsFact,
                                        particle_alpha,
                                        particle_beta,
                                        particle_penalty_constant,
                                        < double * > particle_signed_distances.data,
                                        < double * > particle_signed_distance_normals.data,
                                        < double * > particle_velocities.data,
                                        < double * > particle_centroids.data,
                                        particle_nitsche,
                                        use_ball_as_particle,
                                        < double * > ball_center.data,
                                        < double * > ball_radius.data,
                                        < double * > ball_velocity.data,
                                        < double * > ball_angular_velocity.data,
                                        USE_SUPG,
                                        KILL_PRESSURE_TERM,
                                        dt,
                                        MATERIAL_PARAMETERS_AS_FUNCTION,
                                        < double * > density_as_function.data,
                                        < double * > dynamic_viscosity_as_function.data,
                                        < double * > ebqe_density_as_function.data,
                                        < double * > ebqe_dynamic_viscosity_as_function.data,
                                        USE_SBM)

    def calculateVelocityAverage(self,
                                 int nExteriorElementBoundaries_global,
                                 numpy.ndarray exteriorElementBoundariesArray,
                                 int nInteriorElementBoundaries_global,
                                 numpy.ndarray interiorElementBoundariesArray,
                                 numpy.ndarray elementBoundaryElementsArray,
                                 numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                                 numpy.ndarray mesh_dof,
                                 numpy.ndarray mesh_velocity_dof,
                                 double MOVING_DOMAIN,
                                 numpy.ndarray mesh_l2g,
                                 numpy.ndarray mesh_trial_trace_ref,
                                 numpy.ndarray mesh_grad_trial_trace_ref,
                                 numpy.ndarray normal_ref,
                                 numpy.ndarray boundaryJac_ref,
                                 numpy.ndarray vel_l2g,
                                 numpy.ndarray u_dof,
                                 numpy.ndarray v_dof,
                                 numpy.ndarray w_dof,
                                 numpy.ndarray vos_dof,
                                 numpy.ndarray vel_trial_trace_ref,
                                 numpy.ndarray ebqe_velocity,
                                 numpy.ndarray velocityAverage):

        self.thisptr.calculateVelocityAverage(nExteriorElementBoundaries_global,
                                              < int * > exteriorElementBoundariesArray.data,
                                              nInteriorElementBoundaries_global,
                                              < int * > interiorElementBoundariesArray.data,
                                              < int * > elementBoundaryElementsArray.data,
                                              < int * > elementBoundaryLocalElementBoundariesArray.data,
                                              < double * > mesh_dof.data,
                                              < double * > mesh_velocity_dof.data,
                                              MOVING_DOMAIN,
                                              < int * > mesh_l2g.data,
                                              < double * > mesh_trial_trace_ref.data,
                                              < double * > mesh_grad_trial_trace_ref.data,
                                              < double * > normal_ref.data,
                                              < double * > boundaryJac_ref.data,
                                              < int * > vel_l2g.data,
                                              < double * > u_dof.data,
                                              < double * > v_dof.data,
                                              < double * > w_dof.data,
                                              < double * > vos_dof.data,
                                              < double * > vel_trial_trace_ref.data,
                                              < double * > ebqe_velocity.data,
                                              < double * > velocityAverage.data)


cdef extern from "mprans/RANS3PF2D.h" namespace "proteus":
    cdef cppclass cppRANS3PF2D_base:
        void calculateResidual(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               double PSTAB,
                               int * mesh_l2g,
                               double * dV_ref,
                               int nDOF_per_element_pressure,
                               double * p_trial_ref,
                               double * p_grad_trial_ref,
                               double * p_test_ref,
                               double * p_grad_test_ref,
                               double * q_p,
                               double * q_grad_p,
                               double * ebqe_p,
                               double * ebqe_grad_p,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_hess_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * p_trial_trace_ref,
                               double * p_grad_trial_trace_ref,
                               double * p_test_trace_ref,
                               double * p_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double eb_adjoint_sigma,
                               double * elementDiameter,
                               double * nodeDiametersArray,
                               double hFactor,
                               int nElements_global,
                               int nElements_owned,
                               int nElementBoundaries_owned,
                               int nNodes_owned,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double epsFact_rho,
                               double epsFact_mu,
                               double sigma,
                               double rho_0,
                               double nu_0,
                               double rho_1,
                               double nu_1,
                               double smagorinskyConstant,
                               int turbulenceClosureModel,
                               double Ct_sge,
                               double Cd_sge,
                               double C_dc,
                               double C_b,
                               # VRANS start
                               double * eps_solid,
                               double * ebq_global_phi_solid,
                               double * ebq_global_grad_phi_solid,
                               double * ebq_particle_velocity_solid,
                               double * phi_solid_nodes,
                               double * phi_solid,
                               double * q_velocity_solid,
                               double * q_vos,
                               double * q_dvos_dt,
                               double * q_grad_vos,
                               double * q_dragAlpha,
                               double * q_dragBeta,
                               double * q_mass_source,
                               double * q_turb_var_0,
                               double * q_turb_var_1,
                               double * q_turb_var_grad_0,
                               double * q_eddy_viscosity,
                               # VRANS end
                               int * p_l2g,
                               int * vel_l2g,
                               double * p_dof,
                               double * u_dof,
                               double * v_dof,
                               double * w_dof,
                               double * u_dof_old,
                               double * v_dof_old,
                               double * w_dof_old,
                               double * u_dof_old_old,
                               double * v_dof_old_old,
                               double * w_dof_old_old,
                               double * g,
                               double useVF,
                               double * vf,
                               double * phi,
                               double * normal_phi,
                               double * kappa_phi,
                               double * q_mom_u_acc,
                               double * q_mom_v_acc,
                               double * q_mom_w_acc,
                               double * q_mass_adv,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_mom_w_acc_beta_bdf,
                               double * q_dV,
                               double * q_dV_last,
                               double * q_velocity_sge,
                               double * ebqe_velocity_star,
                               double * q_cfl,
                               double * q_numDiff_u, double * q_numDiff_v, double * q_numDiff_w,
                               double * q_numDiff_u_last, double * q_numDiff_v_last, double * q_numDiff_w_last,
                               int * sdInfo_u_u_rowptr, int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr, int * sdInfo_u_v_colind,
                               int * sdInfo_u_w_rowptr, int * sdInfo_u_w_colind,
                               int * sdInfo_v_v_rowptr, int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr, int * sdInfo_v_u_colind,
                               int * sdInfo_v_w_rowptr, int * sdInfo_v_w_colind,
                               int * sdInfo_w_w_rowptr, int * sdInfo_w_w_colind,
                               int * sdInfo_w_u_rowptr, int * sdInfo_w_u_colind,
                               int * sdInfo_w_v_rowptr, int * sdInfo_w_v_colind,
                               int offset_p, int offset_u, int offset_v, int offset_w,
                               int stride_p, int stride_u, int stride_v, int stride_w,
                               double * globalResidual,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_vf_ext,
                               double * bc_ebqe_vf_ext,
                               double * ebqe_phi_ext,
                               double * bc_ebqe_phi_ext,
                               double * ebqe_normal_phi_ext,
                               double * ebqe_kappa_phi_ext,
                               # VRANS start
                               double * ebqe_vos_ext,
                               double * ebqe_turb_var_0,
                               double * ebqe_turb_var_1,
                               # VRANS end
                               int * isDOFBoundary_p,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isDOFBoundary_w,
                               int * isAdvectiveFluxBoundary_p,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isAdvectiveFluxBoundary_w,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_w,
                               double * ebqe_bc_p_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_flux_mom_w_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_penalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               double * ebqe_bc_w_ext,
                               double * ebqe_bc_flux_w_diff_ext,
                               double * q_x,
                               double * q_velocity,
                               double * ebqe_velocity,
                               double * q_grad_u,
                               double * q_grad_v,
                               double * q_grad_w,
                               double * q_divU,
                               double * ebqe_grad_u,
                               double * ebqe_grad_v,
                               double * ebqe_grad_w,
                               double * flux,
                               double * elementResidual_p,
                               int * elementFlags,
                               int * boundaryFlags,
                               double * barycenters,
                               double * wettedAreas,
                               double * netForces_p,
                               double * netForces_v,
                               double * netMoments,
                               double * q_rho,
                               double * ebqe_rho,
                               double * q_nu,
                               double * ebqe_nu,
                               int nParticles,
                               double particle_epsFact,
                               double particle_alpha,
                               double particle_beta,
                               double particle_penalty_constant,
                               double * particle_signed_distances,
                               double * particle_signed_distance_normals,
                               double * particle_velocities,
                               double * particle_centroids,
                               double * particle_netForces,
                               double * particle_netMoments,
                               double * particle_surfacArea,
                               double particle_nitsche,
                               int use_ball_as_particle,
                               double* ball_center,
                               double* ball_radius,
                               double* ball_velocity,
                               double* ball_angular_velocity,
                               double * phisError,
                               double * phisErrorNodal,
                               int USE_SUPG,
                               int ARTIFICIAL_VISCOSITY,
                               double cMax,
                               double cE,
                               int MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                               double * forcex,
                               double * forcey,
                               double * forcez,
                               int KILL_PRESSURE_TERM,
                               double dt,
                               double * quantDOFs,
                               int MATERIAL_PARAMETERS_AS_FUNCTION,
                               double * density_as_function,
                               double * dynamic_viscosity_as_function,
                               double * ebqe_density_as_function,
                               double * ebqe_dynamic_viscosity_as_function,
                               double order_polynomial,
                               double* isActiveDOF,
                               int USE_SBM)
        void calculateJacobian(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               double PSTAB,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * p_trial_ref,
                               double * p_grad_trial_ref,
                               double * p_test_ref,
                               double * p_grad_test_ref,
                               double * q_p,
                               double * q_grad_p,
                               double * ebqe_p,
                               double * ebqe_grad_p,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_hess_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * p_trial_trace_ref,
                               double * p_grad_trial_trace_ref,
                               double * p_test_trace_ref,
                               double * p_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double eb_adjoint_sigma,
                               double * elementDiameter,
                               double * nodeDiametersArray,
                               double hFactor,
                               int nElements_global,
                               int nElements_owned,
                               int nElementBoundaries_owned,
                               int nNodes_owned,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double epsFact_rho,
                               double epsFact_mu,
                               double sigma,
                               double rho_0,
                               double nu_0,
                               double rho_1,
                               double nu_1,
                               double smagorinskyConstant,
                               int turbulenceClosureModel,
                               double Ct_sge,
                               double Cd_sge,
                               double C_dg,
                               double C_b,
                               # VRANS start
                               double * eps_solid,
                               double * ebq_global_phi_solid,
                               double * ebq_global_grad_phi_solid,
                               double * ebq_particle_velocity_solid,
                               double * phi_solid_nodes,
                               double * phi_solid,
                               double * q_velocity_solid,
                               double * q_vos,
                               double * q_dvos_dt,
                               double * q_grad_vos,
                               double * q_dragAlpha,
                               double * q_dragBeta,
                               double * q_mass_source,
                               double * q_turb_var_0,
                               double * q_turb_var_1,
                               double * q_turb_var_grad_0,
                               # VRANS end
                               int * p_l2g,
                               int * vel_l2g,
                               double * p_dof, double * u_dof, double * v_dof, double * w_dof,
                               double * g,
                               double useVF,
                               double * vf,
                               double * phi,
                               double * normal_phi,
                               double * kappa_phi,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_mom_w_acc_beta_bdf,
                               double * q_dV,
                               double * q_dV_last,
                               double * q_velocity_sge,
                               double * ebqe_velocity_star,
                               double * q_cfl,
                               double * q_numDiff_u_last, double * q_numDiff_v_last, double * q_numDiff_w_last,
                               int * sdInfo_u_u_rowptr, int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr, int * sdInfo_u_v_colind,
                               int * sdInfo_u_w_rowptr, int * sdInfo_u_w_colind,
                               int * sdInfo_v_v_rowptr, int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr, int * sdInfo_v_u_colind,
                               int * sdInfo_v_w_rowptr, int * sdInfo_v_w_colind,
                               int * sdInfo_w_w_rowptr, int * sdInfo_w_w_colind,
                               int * sdInfo_w_u_rowptr, int * sdInfo_w_u_colind,
                               int * sdInfo_w_v_rowptr, int * sdInfo_w_v_colind,
                               int * csrRowIndeces_p_p, int * csrColumnOffsets_p_p,
                               int * csrRowIndeces_p_u, int * csrColumnOffsets_p_u,
                               int * csrRowIndeces_p_v, int * csrColumnOffsets_p_v,
                               int * csrRowIndeces_p_w, int * csrColumnOffsets_p_w,
                               int * csrRowIndeces_u_p, int * csrColumnOffsets_u_p,
                               int * csrRowIndeces_u_u, int * csrColumnOffsets_u_u,
                               int * csrRowIndeces_u_v, int * csrColumnOffsets_u_v,
                               int * csrRowIndeces_u_w, int * csrColumnOffsets_u_w,
                               int * csrRowIndeces_v_p, int * csrColumnOffsets_v_p,
                               int * csrRowIndeces_v_u, int * csrColumnOffsets_v_u,
                               int * csrRowIndeces_v_v, int * csrColumnOffsets_v_v,
                               int * csrRowIndeces_v_w, int * csrColumnOffsets_v_w,
                               int * csrRowIndeces_w_p, int * csrColumnOffsets_w_p,
                               int * csrRowIndeces_w_u, int * csrColumnOffsets_w_u,
                               int * csrRowIndeces_w_v, int * csrColumnOffsets_w_v,
                               int * csrRowIndeces_w_w, int * csrColumnOffsets_w_w,
                               double * globalJacobian,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_vf_ext,
                               double * bc_ebqe_vf_ext,
                               double * ebqe_phi_ext,
                               double * bc_ebqe_phi_ext,
                               double * ebqe_normal_phi_ext,
                               double * ebqe_kappa_phi_ext,
                               # VRANS start
                               double * ebqe_vos_ext,
                               double * ebqe_turb_var_0,
                               double * ebqe_turb_var_1,
                               # VRANS end
                               int * isDOFBoundary_p,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isDOFBoundary_w,
                               int * isAdvectiveFluxBoundary_p,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isAdvectiveFluxBoundary_w,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_w,
                               double * ebqe_bc_p_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_flux_mom_w_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_penalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               double * ebqe_bc_w_ext,
                               double * ebqe_bc_flux_w_diff_ext,
                               int * csrColumnOffsets_eb_p_p,
                               int * csrColumnOffsets_eb_p_u,
                               int * csrColumnOffsets_eb_p_v,
                               int * csrColumnOffsets_eb_p_w,
                               int * csrColumnOffsets_eb_u_p,
                               int * csrColumnOffsets_eb_u_u,
                               int * csrColumnOffsets_eb_u_v,
                               int * csrColumnOffsets_eb_u_w,
                               int * csrColumnOffsets_eb_v_p,
                               int * csrColumnOffsets_eb_v_u,
                               int * csrColumnOffsets_eb_v_v,
                               int * csrColumnOffsets_eb_v_w,
                               int * csrColumnOffsets_eb_w_p,
                               int * csrColumnOffsets_eb_w_u,
                               int * csrColumnOffsets_eb_w_v,
                               int * csrColumnOffsets_eb_w_w,
                               int * elementFlags,
                               int nParticles,
                               double particle_epsFact,
                               double particle_alpha,
                               double particle_beta,
                               double particle_penalty_constant,
                               double * particle_signed_distances,
                               double * particle_signed_distance_normals,
                               double * particle_velocities,
                               double * particle_centroids,
                               double particle_nitsche,
                               int use_ball_as_particle,
                               double* ball_center,
                               double* ball_radius,
                               double* ball_velocity,
                               double* ball_angular_velocity,
                               int USE_SUPG,
                               int KILL_PRESSURE_TERM,
                               double dt,
                               int MATERIAL_PARAMETERS_AS_FUNCTION,
                               double * density_as_function,
                               double * dynamic_viscosity_as_function,
                               double * ebqe_density_as_function,
                               double * ebqe_dynamic_viscosity_as_function,
                               int USE_SBM)
        void calculateVelocityAverage(int nExteriorElementBoundaries_global,
                                      int * exteriorElementBoundariesArray,
                                      int nInteriorElementBoundaries_global,
                                      int * interiorElementBoundariesArray,
                                      int * elementBoundaryElementsArray,
                                      int * elementBoundaryLocalElementBoundariesArray,
                                      double * mesh_dof,
                                      double * mesh_velocity_dof,
                                      double MOVING_DOMAIN,
                                      int * mesh_l2g,
                                      double * mesh_trial_trace_ref,
                                      double * mesh_grad_trial_trace_ref,
                                      double * normal_ref,
                                      double * boundaryJac_ref,
                                      int * vel_l2g,
                                      double * u_dof,
                                      double * v_dof,
                                      double * w_dof,
                                      double * vos_dof,
                                      double * vel_trial_trace_ref,
                                      double * ebqe_velocity,
                                      double * velocityAverage)

    cppRANS3PF2D_base * newRANS3PF2D(int nSpaceIn,
                                     int nQuadraturePoints_elementIn,
                                     int nDOF_mesh_trial_elementIn,
                                     int nDOF_trial_elementIn,
                                     int nDOF_test_elementIn,
                                     int nQuadraturePoints_elementBoundaryIn,
                                     int CompKernelFlag,
                                     double aDarcy,
                                     double betaForch,
                                     double grain,
                                     double packFraction,
                                     double packMargin,
                                     double maxFraction,
                                     double frFraction,
                                     double sigmaC,
                                     double C3e,
                                     double C4e,
                                     double eR,
                                     double fContact,
                                     double mContact,
                                     double nContact,
                                     double angFriction,
                                     double vos_limiter,
                                     double mu_fr_limiter,
                                      )

cdef class RANS3PF2D:
    cdef cppRANS3PF2D_base * thisptr

    def __cinit__(self,
                  int nSpaceIn,
                  int nQuadraturePoints_elementIn,
                  int nDOF_mesh_trial_elementIn,
                  int nDOF_trial_elementIn,
                  int nDOF_test_elementIn,
                  int nQuadraturePoints_elementBoundaryIn,
                  int CompKernelFlag,
                  double aDarcy,
                  double betaForch,
                  double grain,
                  double packFraction,
                  double packMargin,
                  double maxFraction,
                  double frFraction,
                  double sigmaC,
                  double C3e,
                  double C4e,
                  double eR,
                  double fContact,
                  double mContact,
                  double nContact,
                  double angFriction,
                  double vos_limiter,
                  double mu_fr_limiter,
                  ):
        self.thisptr = newRANS3PF2D(nSpaceIn,
                                    nQuadraturePoints_elementIn,
                                    nDOF_mesh_trial_elementIn,
                                    nDOF_trial_elementIn,
                                    nDOF_test_elementIn,
                                    nQuadraturePoints_elementBoundaryIn,
                                    CompKernelFlag,
                                    aDarcy,
                                    betaForch,
                                    grain,
                                    packFraction,
                                    packMargin,
                                    maxFraction,
                                    frFraction,
                                    sigmaC,
                                    C3e,
                                    C4e,
                                    eR,
                                    fContact,
                                    mContact,
                                    nContact,
                                    angFriction,
                                    vos_limiter,
                                    mu_fr_limiter,
                                    )

    def __dealloc__(self):
        del self.thisptr

    def calculateResidual(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          double PSTAB,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          int nDOF_per_element_pressure,
                          numpy.ndarray p_trial_ref,
                          numpy.ndarray p_grad_trial_ref,
                          numpy.ndarray p_test_ref,
                          numpy.ndarray p_grad_test_ref,
                          numpy.ndarray q_p,
                          numpy.ndarray q_grad_p,
                          numpy.ndarray ebqe_p,
                          numpy.ndarray ebqe_grad_p,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_hess_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray p_trial_trace_ref,
                          numpy.ndarray p_grad_trial_trace_ref,
                          numpy.ndarray p_test_trace_ref,
                          numpy.ndarray p_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          double eb_adjoint_sigma,
                          numpy.ndarray elementDiameter,
                          numpy.ndarray nodeDiametersArray,
                          double hFactor,
                          int nElements_global,
                          int nElements_owned,
                          int nElementBoundaries_owned,
                          int nNodes_owned,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double epsFact_rho,
                          double epsFact_mu,
                          double sigma,
                          double rho_0,
                          double nu_0,
                          double rho_1,
                          double nu_1,
                          double smagorinskyConstant,
                          int turbulenceClosureModel,
                          double Ct_sge,
                          double Cd_sge,
                          double C_dc,
                          double C_b,
                          # VRANS start
                          numpy.ndarray eps_solid,
                          numpy.ndarray ebq_global_phi_solid,
                          numpy.ndarray ebq_global_grad_phi_solid,
                          numpy.ndarray ebq_particle_velocity_solid,
                          numpy.ndarray phi_solid_nodes,
                          numpy.ndarray phi_solid,
                          numpy.ndarray q_velocity_solid,
                          numpy.ndarray q_vos,
                          numpy.ndarray q_dvos_dt,
                          numpy.ndarray q_grad_vos,
                          numpy.ndarray q_dragAlpha,
                          numpy.ndarray q_dragBeta,
                          numpy.ndarray q_mass_source,
                          numpy.ndarray q_turb_var_0,
                          numpy.ndarray q_turb_var_1,
                          numpy.ndarray q_turb_var_grad_0,
                          numpy.ndarray q_eddy_viscosity,
                          # VRANS end
                          numpy.ndarray p_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray p_dof,
                          numpy.ndarray u_dof,
                          numpy.ndarray v_dof,
                          numpy.ndarray w_dof,
                          numpy.ndarray u_dof_old,
                          numpy.ndarray v_dof_old,
                          numpy.ndarray w_dof_old,
                          numpy.ndarray u_dof_old_old,
                          numpy.ndarray v_dof_old_old,
                          numpy.ndarray w_dof_old_old,
                          numpy.ndarray g,
                          double useVF,
                          numpy.ndarray vf,
                          numpy.ndarray phi,
                          numpy.ndarray normal_phi,
                          numpy.ndarray kappa_phi,
                          numpy.ndarray q_mom_u_acc,
                          numpy.ndarray q_mom_v_acc,
                          numpy.ndarray q_mom_w_acc,
                          numpy.ndarray q_mass_adv,
                          numpy.ndarray q_mom_u_acc_beta_bdf, numpy.ndarray q_mom_v_acc_beta_bdf, numpy.ndarray q_mom_w_acc_beta_bdf,
                          numpy.ndarray q_dV,
                          numpy.ndarray q_dV_last,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray ebqe_velocity_star,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_u, numpy.ndarray q_numDiff_v, numpy.ndarray q_numDiff_w,
                          numpy.ndarray q_numDiff_u_last, numpy.ndarray q_numDiff_v_last, numpy.ndarray q_numDiff_w_last,
                          numpy.ndarray sdInfo_u_u_rowptr, numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr, numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_u_w_rowptr, numpy.ndarray sdInfo_u_w_colind,
                          numpy.ndarray sdInfo_v_v_rowptr, numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr, numpy.ndarray sdInfo_v_u_colind,
                          numpy.ndarray sdInfo_v_w_rowptr, numpy.ndarray sdInfo_v_w_colind,
                          numpy.ndarray sdInfo_w_w_rowptr, numpy.ndarray sdInfo_w_w_colind,
                          numpy.ndarray sdInfo_w_u_rowptr, numpy.ndarray sdInfo_w_u_colind,
                          numpy.ndarray sdInfo_w_v_rowptr, numpy.ndarray sdInfo_w_v_colind,
                          int offset_p, int offset_u, int offset_v, int offset_w,
                          int stride_p, int stride_u, int stride_v, int stride_w,
                          numpy.ndarray globalResidual,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_vf_ext,
                          numpy.ndarray bc_ebqe_vf_ext,
                          numpy.ndarray ebqe_phi_ext,
                          numpy.ndarray bc_ebqe_phi_ext,
                          numpy.ndarray ebqe_normal_phi_ext,
                          numpy.ndarray ebqe_kappa_phi_ext,
                          # VRANS start
                          numpy.ndarray ebqe_vos_ext,
                          numpy.ndarray ebqe_turb_var_0,
                          numpy.ndarray ebqe_turb_var_1,
                          # VRANS end
                          numpy.ndarray isDOFBoundary_p,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isDOFBoundary_w,
                          numpy.ndarray isAdvectiveFluxBoundary_p,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_w,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_w,
                          numpy.ndarray ebqe_bc_p_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_w_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_penalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray ebqe_bc_w_ext,
                          numpy.ndarray ebqe_bc_flux_w_diff_ext,
                          numpy.ndarray q_x,
                          numpy.ndarray q_velocity,
                          numpy.ndarray ebqe_velocity,
                          numpy.ndarray q_grad_u,
                          numpy.ndarray q_grad_v,
                          numpy.ndarray q_grad_w,
                          numpy.ndarray q_divU,
                          numpy.ndarray ebqe_grad_u,
                          numpy.ndarray ebqe_grad_v,
                          numpy.ndarray ebqe_grad_w,
                          numpy.ndarray flux,
                          numpy.ndarray elementResidual_p,
                          numpy.ndarray elementFlags,
                          numpy.ndarray boundaryFlags,
                          numpy.ndarray barycenters,
                          numpy.ndarray wettedAreas,
                          numpy.ndarray netForces_p,
                          numpy.ndarray netForces_v,
                          numpy.ndarray netMoments,
                          numpy.ndarray q_rho,
                          numpy.ndarray ebqe_rho,
                          numpy.ndarray q_nu,
                          numpy.ndarray ebqe_nu,
                          int nParticles,
                          double particle_epsFact,
                          double particle_alpha,
                          double particle_beta,
                          double particle_penalty_constant,
                          numpy.ndarray particle_signed_distances,
                          numpy.ndarray particle_signed_distance_normals,
                          numpy.ndarray particle_velocities,
                          numpy.ndarray particle_centroids,
                          numpy.ndarray particle_netForces,
                          numpy.ndarray particle_netMoments,
                          numpy.ndarray particle_surfaceArea,
                          double particle_nitsche,
                          int use_ball_as_particle,
                          numpy.ndarray ball_center,
                          numpy.ndarray ball_radius,
                          numpy.ndarray ball_velocity,
                          numpy.ndarray ball_angular_velocity,
                          numpy.ndarray phisError,
                          numpy.ndarray phisErrorNodal,
                          int USE_SUPG,
                          int ARTIFICIAL_VISCOSITY,
                          double cMax,
                          double cE,
                          int MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                          numpy.ndarray forcex,
                          numpy.ndarray forcey,
                          numpy.ndarray forcez,
                          int KILL_PRESSURE_TERM,
                          double dt,
                          numpy.ndarray quantDOFs,
                          int MATERIAL_PARAMETERS_AS_FUNCTION,
                          numpy.ndarray density_as_function,
                          numpy.ndarray dynamic_viscosity_as_function,
                          numpy.ndarray ebqe_density_as_function,
                          numpy.ndarray ebqe_dynamic_viscosity_as_function,
                          double order_polynomial,
                          numpy.ndarray isActiveDOF,
                          int USE_SBM):
        self.thisptr.calculateResidual(< double * > mesh_trial_ref.data,
                                       < double * > mesh_grad_trial_ref.data,
                                       < double * > mesh_dof.data,
                                       < double * > mesh_velocity_dof.data,
                                       MOVING_DOMAIN,
                                       PSTAB,
                                       < int * > mesh_l2g.data,
                                       < double * > dV_ref.data,
                                       nDOF_per_element_pressure,
                                       < double * > p_trial_ref.data,
                                       < double * > p_grad_trial_ref.data,
                                       < double * > p_test_ref.data,
                                       < double * > p_grad_test_ref.data,
                                       < double * > q_p.data,
                                       < double * > q_grad_p.data,
                                       < double * > ebqe_p.data,
                                       < double * > ebqe_grad_p.data,
                                       < double * > vel_trial_ref.data,
                                       < double * > vel_grad_trial_ref.data,
                                       < double * > vel_hess_trial_ref.data,
                                       < double * > vel_test_ref.data,
                                       < double * > vel_grad_test_ref.data,
                                       < double * > mesh_trial_trace_ref.data,
                                       < double * > mesh_grad_trial_trace_ref.data,
                                       < double * > dS_ref.data,
                                       < double * > p_trial_trace_ref.data,
                                       < double * > p_grad_trial_trace_ref.data,
                                       < double * > p_test_trace_ref.data,
                                       < double * > p_grad_test_trace_ref.data,
                                       < double * > vel_trial_trace_ref.data,
                                       < double * > vel_grad_trial_trace_ref.data,
                                       < double * > vel_test_trace_ref.data,
                                       < double * > vel_grad_test_trace_ref.data,
                                       < double * > normal_ref.data,
                                       < double * > boundaryJac_ref.data,
                                       eb_adjoint_sigma,
                                       < double * > elementDiameter.data,
                                       < double * > nodeDiametersArray.data,
                                       hFactor,
                                       nElements_global,
                                       nElements_owned,
                                       nElementBoundaries_owned,
                                       nNodes_owned,
                                       useRBLES,
                                       useMetrics,
                                       alphaBDF,
                                       epsFact_rho,
                                       epsFact_mu,
                                       sigma,
                                       rho_0,
                                       nu_0,
                                       rho_1,
                                       nu_1,
                                       smagorinskyConstant,
                                       turbulenceClosureModel,
                                       Ct_sge,
                                       Cd_sge,
                                       C_dc,
                                       C_b,
                                       < double* > eps_solid.data,
                                       < double* > ebq_global_phi_solid.data,
                                       < double* > ebq_global_grad_phi_solid.data,
                                       < double* > ebq_particle_velocity_solid.data,
                                       < double* > phi_solid_nodes.data,
                                       < double * > phi_solid.data,
                                       < double * > q_velocity_solid.data,
                                       < double * > q_vos.data,
                                       < double * > q_dvos_dt.data,
                                       < double * > q_grad_vos.data,
                                       < double * > q_dragAlpha.data,
                                       < double * > q_dragBeta.data,
                                       < double * > q_mass_source.data,
                                       < double * > q_turb_var_0.data,
                                       < double * > q_turb_var_1.data,
                                       < double * > q_turb_var_grad_0.data,
                                       < double * > q_eddy_viscosity.data,
                                       < int * > p_l2g.data,
                                       < int * > vel_l2g.data,
                                       < double * > p_dof.data,
                                       < double * > u_dof.data,
                                       < double * > v_dof.data,
                                       < double * > w_dof.data,
                                       < double * > u_dof_old.data,
                                       < double * > v_dof_old.data,
                                       < double * > w_dof_old.data,
                                       < double * > u_dof_old_old.data,
                                       < double * > v_dof_old_old.data,
                                       < double * > w_dof_old_old.data,
                                       < double * > g.data,
                                       useVF,
                                       < double * > vf.data,
                                       < double * > phi.data,
                                       < double * > normal_phi.data,
                                       < double * > kappa_phi.data,
                                       < double * > q_mom_u_acc.data,
                                       < double * > q_mom_v_acc.data,
                                       < double * > q_mom_w_acc.data,
                                       < double * > q_mass_adv.data,
                                       < double * > q_mom_u_acc_beta_bdf.data, < double * > q_mom_v_acc_beta_bdf.data, < double * > q_mom_w_acc_beta_bdf.data,
                                       < double * > q_dV.data,
                                       < double * > q_dV_last.data,
                                       < double * > q_velocity_sge.data,
                                       < double * > ebqe_velocity_star.data,
                                       < double * > q_cfl.data,
                                       < double * > q_numDiff_u.data, < double * > q_numDiff_v.data, < double * > q_numDiff_w.data,
                                       < double * > q_numDiff_u_last.data, < double * > q_numDiff_v_last.data, < double * > q_numDiff_w_last.data,
                                       < int * > sdInfo_u_u_rowptr.data, < int * > sdInfo_u_u_colind.data,
                                       < int * > sdInfo_u_v_rowptr.data, < int * > sdInfo_u_v_colind.data,
                                       < int * > sdInfo_u_w_rowptr.data, < int * > sdInfo_u_w_colind.data,
                                       < int * > sdInfo_v_v_rowptr.data, < int * > sdInfo_v_v_colind.data,
                                       < int * > sdInfo_v_u_rowptr.data, < int * > sdInfo_v_u_colind.data,
                                       < int * > sdInfo_v_w_rowptr.data, < int * > sdInfo_v_w_colind.data,
                                       < int * > sdInfo_w_w_rowptr.data, < int * > sdInfo_w_w_colind.data,
                                       < int * > sdInfo_w_u_rowptr.data, < int * > sdInfo_w_u_colind.data,
                                       < int * > sdInfo_w_v_rowptr.data, < int * > sdInfo_w_v_colind.data,
                                       offset_p, offset_u, offset_v, offset_w,
                                       stride_p, stride_u, stride_v, stride_w,
                                       < double * > globalResidual.data,
                                       nExteriorElementBoundaries_global,
                                       < int * > exteriorElementBoundariesArray.data,
                                       < int * > elementBoundariesArray.data,
                                       < int * > elementBoundaryElementsArray.data,
                                       < int * > elementBoundaryLocalElementBoundariesArray.data,
                                       < double * > ebqe_vf_ext.data,
                                       < double * > bc_ebqe_vf_ext.data,
                                       < double * > ebqe_phi_ext.data,
                                       < double * > bc_ebqe_phi_ext.data,
                                       < double * > ebqe_normal_phi_ext.data,
                                       < double * > ebqe_kappa_phi_ext.data,
                                       < double * > ebqe_vos_ext.data,
                                       < double * > ebqe_turb_var_0.data,
                                       < double * > ebqe_turb_var_1.data,
                                       < int * > isDOFBoundary_p.data,
                                       < int * > isDOFBoundary_u.data,
                                       < int * > isDOFBoundary_v.data,
                                       < int * > isDOFBoundary_w.data,
                                       < int * > isAdvectiveFluxBoundary_p.data,
                                       < int * > isAdvectiveFluxBoundary_u.data,
                                       < int * > isAdvectiveFluxBoundary_v.data,
                                       < int * > isAdvectiveFluxBoundary_w.data,
                                       < int * > isDiffusiveFluxBoundary_u.data,
                                       < int * > isDiffusiveFluxBoundary_v.data,
                                       < int * > isDiffusiveFluxBoundary_w.data,
                                       < double * > ebqe_bc_p_ext.data,
                                       < double * > ebqe_bc_flux_mass_ext.data,
                                       < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                       < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                       < double * > ebqe_bc_flux_mom_w_adv_ext.data,
                                       < double * > ebqe_bc_u_ext.data,
                                       < double * > ebqe_bc_flux_u_diff_ext.data,
                                       < double * > ebqe_penalty_ext.data,
                                       < double * > ebqe_bc_v_ext.data,
                                       < double * > ebqe_bc_flux_v_diff_ext.data,
                                       < double * > ebqe_bc_w_ext.data,
                                       < double * > ebqe_bc_flux_w_diff_ext.data,
                                       < double * > q_x.data,
                                       < double * > q_velocity.data,
                                       < double * > ebqe_velocity.data,
                                       < double * > q_grad_u.data,
                                       < double * > q_grad_v.data,
                                       < double * > q_grad_w.data,
                                       < double * > q_divU.data,
                                       < double * > ebqe_grad_u.data,
                                       < double * > ebqe_grad_v.data,
                                       < double * > ebqe_grad_w.data,
                                       < double * > flux.data,
                                       < double * > elementResidual_p.data,
                                       < int * > elementFlags.data,
                                       < int * > boundaryFlags.data,
                                       < double * > barycenters.data,
                                       < double * > wettedAreas.data,
                                       < double * > netForces_p.data,
                                       < double * > netForces_v.data,
                                       < double * > netMoments.data,
                                       < double * > q_rho.data,
                                       < double * > ebqe_rho.data,
                                       < double * > q_nu.data,
                                       < double * > ebqe_nu.data,
                                       nParticles,
                                       particle_epsFact,
                                       particle_alpha,
                                       particle_beta,
                                       particle_penalty_constant,
                                       < double * > particle_signed_distances.data,
                                       < double * > particle_signed_distance_normals.data,
                                       < double * > particle_velocities.data,
                                       < double * > particle_centroids.data,
                                       < double * > particle_netForces.data,
                                       < double * > particle_netMoments.data,
                                       < double * > particle_surfaceArea.data,
                                       particle_nitsche,
                                       use_ball_as_particle,
                                       < double * > ball_center.data,
                                       < double * > ball_radius.data,
                                       < double * > ball_velocity.data,
                                       < double * > ball_angular_velocity.data,
                                       < double * > phisError.data,
                                       < double * > phisErrorNodal.data,
                                       USE_SUPG,
                                       ARTIFICIAL_VISCOSITY,
                                       cMax,
                                       cE,
                                       MULTIPLY_EXTERNAL_FORCE_BY_DENSITY,
                                       < double * > forcex.data,
                                       < double * > forcey.data,
                                       < double * > forcez.data,
                                       KILL_PRESSURE_TERM,
                                       dt,
                                       < double * > quantDOFs.data,
                                       MATERIAL_PARAMETERS_AS_FUNCTION,
                                       < double * > density_as_function.data,
                                       < double * > dynamic_viscosity_as_function.data,
                                       < double * > ebqe_density_as_function.data,
                                       < double * > ebqe_dynamic_viscosity_as_function.data,
                                       order_polynomial,
                                       < double *> isActiveDOF.data,
                                       USE_SBM)
    def calculateJacobian(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          double PSTAB,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray p_trial_ref,
                          numpy.ndarray p_grad_trial_ref,
                          numpy.ndarray p_test_ref,
                          numpy.ndarray p_grad_test_ref,
                          numpy.ndarray q_p,
                          numpy.ndarray q_grad_p,
                          numpy.ndarray ebqe_p,
                          numpy.ndarray ebqe_grad_p,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_hess_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray p_trial_trace_ref,
                          numpy.ndarray p_grad_trial_trace_ref,
                          numpy.ndarray p_test_trace_ref,
                          numpy.ndarray p_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          double eb_adjoint_sigma,
                          numpy.ndarray elementDiameter,
                          numpy.ndarray nodeDiametersArray,
                          double hFactor,
                          int nElements_global,
                          int nElements_owned,
                          int nElementBoundaries_owned,
                          int nNodes_owned,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double epsFact_rho,
                          double epsFact_mu,
                          double sigma,
                          double rho_0,
                          double nu_0,
                          double rho_1,
                          double nu_1,
                          double smagorinskyConstant,
                          int turbulenceClosureModel,
                          double Ct_sge,
                          double Cd_sge,
                          double C_dg,
                          double C_b,
                          # VRANS start
                          numpy.ndarray eps_solid,
                          numpy.ndarray ebq_global_phi_solid,
                          numpy.ndarray ebq_global_grad_phi_solid,
                          numpy.ndarray ebq_particle_velocity_solid,
                          numpy.ndarray phi_solid_nodes,
                          numpy.ndarray phi_solid,
                          numpy.ndarray q_velocity_solid,
                          numpy.ndarray q_vos,
                          numpy.ndarray q_dvos_dt,
                          numpy.ndarray q_grad_vos,
                          numpy.ndarray q_dragAlpha,
                          numpy.ndarray q_dragBeta,
                          numpy.ndarray q_mass_source,
                          numpy.ndarray q_turb_var_0,
                          numpy.ndarray q_turb_var_1,
                          numpy.ndarray q_turb_var_grad_0,
                          # VRANS end
                          numpy.ndarray p_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray p_dof, numpy.ndarray u_dof, numpy.ndarray v_dof, numpy.ndarray w_dof,
                          numpy.ndarray g,
                          double useVF,
                          numpy.ndarray vf,
                          numpy.ndarray phi,
                          numpy.ndarray normal_phi,
                          numpy.ndarray kappa_phi,
                          numpy.ndarray q_mom_u_acc_beta_bdf, numpy.ndarray q_mom_v_acc_beta_bdf, numpy.ndarray q_mom_w_acc_beta_bdf,
                          numpy.ndarray q_dV,
                          numpy.ndarray q_dV_last,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray ebqe_velocity_star,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_u_last, numpy.ndarray q_numDiff_v_last, numpy.ndarray q_numDiff_w_last,
                          numpy.ndarray sdInfo_u_u_rowptr, numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr, numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_u_w_rowptr, numpy.ndarray sdInfo_u_w_colind,
                          numpy.ndarray sdInfo_v_v_rowptr, numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr, numpy.ndarray sdInfo_v_u_colind,
                          numpy.ndarray sdInfo_v_w_rowptr, numpy.ndarray sdInfo_v_w_colind,
                          numpy.ndarray sdInfo_w_w_rowptr, numpy.ndarray sdInfo_w_w_colind,
                          numpy.ndarray sdInfo_w_u_rowptr, numpy.ndarray sdInfo_w_u_colind,
                          numpy.ndarray sdInfo_w_v_rowptr, numpy.ndarray sdInfo_w_v_colind,
                          numpy.ndarray csrRowIndeces_p_p, numpy.ndarray csrColumnOffsets_p_p,
                          numpy.ndarray csrRowIndeces_p_u, numpy.ndarray csrColumnOffsets_p_u,
                          numpy.ndarray csrRowIndeces_p_v, numpy.ndarray csrColumnOffsets_p_v,
                          numpy.ndarray csrRowIndeces_p_w, numpy.ndarray csrColumnOffsets_p_w,
                          numpy.ndarray csrRowIndeces_u_p, numpy.ndarray csrColumnOffsets_u_p,
                          numpy.ndarray csrRowIndeces_u_u, numpy.ndarray csrColumnOffsets_u_u,
                          numpy.ndarray csrRowIndeces_u_v, numpy.ndarray csrColumnOffsets_u_v,
                          numpy.ndarray csrRowIndeces_u_w, numpy.ndarray csrColumnOffsets_u_w,
                          numpy.ndarray csrRowIndeces_v_p, numpy.ndarray csrColumnOffsets_v_p,
                          numpy.ndarray csrRowIndeces_v_u, numpy.ndarray csrColumnOffsets_v_u,
                          numpy.ndarray csrRowIndeces_v_v, numpy.ndarray csrColumnOffsets_v_v,
                          numpy.ndarray csrRowIndeces_v_w, numpy.ndarray csrColumnOffsets_v_w,
                          numpy.ndarray csrRowIndeces_w_p, numpy.ndarray csrColumnOffsets_w_p,
                          numpy.ndarray csrRowIndeces_w_u, numpy.ndarray csrColumnOffsets_w_u,
                          numpy.ndarray csrRowIndeces_w_v, numpy.ndarray csrColumnOffsets_w_v,
                          numpy.ndarray csrRowIndeces_w_w, numpy.ndarray csrColumnOffsets_w_w,
                          globalJacobian,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_vf_ext,
                          numpy.ndarray bc_ebqe_vf_ext,
                          numpy.ndarray ebqe_phi_ext,
                          numpy.ndarray bc_ebqe_phi_ext,
                          numpy.ndarray ebqe_normal_phi_ext,
                          numpy.ndarray ebqe_kappa_phi_ext,
                          # VRANS start
                          numpy.ndarray ebqe_vos_ext,
                          numpy.ndarray ebqe_turb_var_0,
                          numpy.ndarray ebqe_turb_var_1,
                          # VRANS end
                          numpy.ndarray isDOFBoundary_p,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isDOFBoundary_w,
                          numpy.ndarray isAdvectiveFluxBoundary_p,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_w,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_w,
                          numpy.ndarray ebqe_bc_p_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_w_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_penalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray ebqe_bc_w_ext,
                          numpy.ndarray ebqe_bc_flux_w_diff_ext,
                          numpy.ndarray csrColumnOffsets_eb_p_p,
                          numpy.ndarray csrColumnOffsets_eb_p_u,
                          numpy.ndarray csrColumnOffsets_eb_p_v,
                          numpy.ndarray csrColumnOffsets_eb_p_w,
                          numpy.ndarray csrColumnOffsets_eb_u_p,
                          numpy.ndarray csrColumnOffsets_eb_u_u,
                          numpy.ndarray csrColumnOffsets_eb_u_v,
                          numpy.ndarray csrColumnOffsets_eb_u_w,
                          numpy.ndarray csrColumnOffsets_eb_v_p,
                          numpy.ndarray csrColumnOffsets_eb_v_u,
                          numpy.ndarray csrColumnOffsets_eb_v_v,
                          numpy.ndarray csrColumnOffsets_eb_v_w,
                          numpy.ndarray csrColumnOffsets_eb_w_p,
                          numpy.ndarray csrColumnOffsets_eb_w_u,
                          numpy.ndarray csrColumnOffsets_eb_w_v,
                          numpy.ndarray csrColumnOffsets_eb_w_w,
                          numpy.ndarray elementFlags,
                          int nParticles,
                          double particle_epsFact,
                          double particle_alpha,
                          double particle_beta,
                          double particle_penalty_constant,
                          numpy.ndarray particle_signed_distances,
                          numpy.ndarray particle_signed_distance_normals,
                          numpy.ndarray particle_velocities,
                          numpy.ndarray particle_centroids,
                          double particle_nitsche,
                          int use_ball_as_particle,
                          numpy.ndarray ball_center,
                          numpy.ndarray ball_radius,
                          numpy.ndarray ball_velocity,
                          numpy.ndarray ball_angular_velocity,
                          int USE_SUPG,
                          int KILL_PRESSURE_TERM,
                          double dt,
                          int MATERIAL_PARAMETERS_AS_FUNCTION,
                          numpy.ndarray density_as_function,
                          numpy.ndarray dynamic_viscosity_as_function,
                          numpy.ndarray ebqe_density_as_function,
                          numpy.ndarray ebqe_dynamic_viscosity_as_function,
                          int USE_SBM):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateJacobian(< double * > mesh_trial_ref.data,
                                        < double * > mesh_grad_trial_ref.data,
                                        < double * > mesh_dof.data,
                                        < double * > mesh_velocity_dof.data,
                                        MOVING_DOMAIN,
                                        PSTAB,
                                        < int * > mesh_l2g.data,
                                        < double * > dV_ref.data,
                                        < double * > p_trial_ref.data,
                                        < double * > p_grad_trial_ref.data,
                                        < double * > p_test_ref.data,
                                        < double * > p_grad_test_ref.data,
                                        < double * > q_p.data,
                                        < double * > q_grad_p.data,
                                        < double * > ebqe_p.data,
                                        < double * > ebqe_grad_p.data,
                                        < double * > vel_trial_ref.data,
                                        < double * > vel_grad_trial_ref.data,
                                        < double * > vel_hess_trial_ref.data,
                                        < double * > vel_test_ref.data,
                                        < double * > vel_grad_test_ref.data,
                                        < double * > mesh_trial_trace_ref.data,
                                        < double * > mesh_grad_trial_trace_ref.data,
                                        < double * > dS_ref.data,
                                        < double * > p_trial_trace_ref.data,
                                        < double * > p_grad_trial_trace_ref.data,
                                        < double * > p_test_trace_ref.data,
                                        < double * > p_grad_test_trace_ref.data,
                                        < double * > vel_trial_trace_ref.data,
                                        < double * > vel_grad_trial_trace_ref.data,
                                        < double * > vel_test_trace_ref.data,
                                        < double * > vel_grad_test_trace_ref.data,
                                        < double * > normal_ref.data,
                                        < double * > boundaryJac_ref.data,
                                        eb_adjoint_sigma,
                                        < double * > elementDiameter.data,
                                        < double * > nodeDiametersArray.data,
                                        hFactor,
                                        nElements_global,
                                        nElements_owned,
                                        nElementBoundaries_owned,
                                        nNodes_owned,
                                        useRBLES,
                                        useMetrics,
                                        alphaBDF,
                                        epsFact_rho,
                                        epsFact_mu,
                                        sigma,
                                        rho_0,
                                        nu_0,
                                        rho_1,
                                        nu_1,
                                        smagorinskyConstant,
                                        turbulenceClosureModel,
                                        Ct_sge,
                                        Cd_sge,
                                        C_dg,
                                        C_b,
                                        < double * > eps_solid.data,
                                        < double* > ebq_global_phi_solid.data,
                                        < double* > ebq_global_grad_phi_solid.data,
                                        < double* > ebq_particle_velocity_solid.data,
                                        < double* > phi_solid_nodes.data,
                                        < double * > phi_solid.data,
                                        < double * > q_velocity_solid.data,
                                        < double * > q_vos.data,
                                        < double * > q_dvos_dt.data,
                                       < double * > q_grad_vos.data,
                                        < double * > q_dragAlpha.data,
                                        < double * > q_dragBeta.data,
                                        < double * > q_mass_source.data,
                                        < double * > q_turb_var_0.data,
                                        < double * > q_turb_var_1.data,
                                        < double * > q_turb_var_grad_0.data,
                                        < int * > p_l2g.data,
                                        < int * > vel_l2g.data,
                                        < double * > p_dof.data, < double * > u_dof.data, < double * > v_dof.data, < double * > w_dof.data,
                                        < double * > g.data,
                                        useVF,
                                        < double * > vf.data,
                                        < double * > phi.data,
                                        < double * > normal_phi.data,
                                        < double * > kappa_phi.data,
                                        < double * > q_mom_u_acc_beta_bdf.data, < double * > q_mom_v_acc_beta_bdf.data, < double * > q_mom_w_acc_beta_bdf.data,
                                        < double * > q_dV.data,
                                        < double * > q_dV_last.data,
                                        < double * > q_velocity_sge.data,
                                        < double * > ebqe_velocity_star.data,
                                        < double * > q_cfl.data,
                                        < double * > q_numDiff_u_last.data, < double * > q_numDiff_v_last.data, < double * > q_numDiff_w_last.data,
                                        < int * > sdInfo_u_u_rowptr.data, < int * > sdInfo_u_u_colind.data,
                                        < int * > sdInfo_u_v_rowptr.data, < int * > sdInfo_u_v_colind.data,
                                        < int * > sdInfo_u_w_rowptr.data, < int * > sdInfo_u_w_colind.data,
                                        < int * > sdInfo_v_v_rowptr.data, < int * > sdInfo_v_v_colind.data,
                                        < int * > sdInfo_v_u_rowptr.data, < int * > sdInfo_v_u_colind.data,
                                        < int * > sdInfo_v_w_rowptr.data, < int * > sdInfo_v_w_colind.data,
                                        < int * > sdInfo_w_w_rowptr.data, < int * > sdInfo_w_w_colind.data,
                                        < int * > sdInfo_w_u_rowptr.data, < int * > sdInfo_w_u_colind.data,
                                        < int * > sdInfo_w_v_rowptr.data, < int * > sdInfo_w_v_colind.data,
                                        < int * > csrRowIndeces_p_p.data, < int * > csrColumnOffsets_p_p.data,
                                        < int * > csrRowIndeces_p_u.data, < int * > csrColumnOffsets_p_u.data,
                                        < int * > csrRowIndeces_p_v.data, < int * > csrColumnOffsets_p_v.data,
                                        < int * > csrRowIndeces_p_w.data, < int * > csrColumnOffsets_p_w.data,
                                        < int * > csrRowIndeces_u_p.data, < int * > csrColumnOffsets_u_p.data,
                                        < int * > csrRowIndeces_u_u.data, < int * > csrColumnOffsets_u_u.data,
                                        < int * > csrRowIndeces_u_v.data, < int * > csrColumnOffsets_u_v.data,
                                        < int * > csrRowIndeces_u_w.data, < int * > csrColumnOffsets_u_w.data,
                                        < int * > csrRowIndeces_v_p.data, < int * > csrColumnOffsets_v_p.data,
                                        < int * > csrRowIndeces_v_u.data, < int * > csrColumnOffsets_v_u.data,
                                        < int * > csrRowIndeces_v_v.data, < int * > csrColumnOffsets_v_v.data,
                                        < int * > csrRowIndeces_v_w.data, < int * > csrColumnOffsets_v_w.data,
                                        < int * > csrRowIndeces_w_p.data, < int * > csrColumnOffsets_w_p.data,
                                        < int * > csrRowIndeces_w_u.data, < int * > csrColumnOffsets_w_u.data,
                                        < int * > csrRowIndeces_w_v.data, < int * > csrColumnOffsets_w_v.data,
                                        < int * > csrRowIndeces_w_w.data, < int * > csrColumnOffsets_w_w.data,
                                        < double * > globalJacobian_a.data,
                                        nExteriorElementBoundaries_global,
                                        < int * > exteriorElementBoundariesArray.data,
                                        < int * > elementBoundariesArray.data,
                                        < int * > elementBoundaryElementsArray.data,
                                        < int * > elementBoundaryLocalElementBoundariesArray.data,
                                        < double * > ebqe_vf_ext.data,
                                        < double * > bc_ebqe_vf_ext.data,
                                        < double * > ebqe_phi_ext.data,
                                        < double * > bc_ebqe_phi_ext.data,
                                        < double * > ebqe_normal_phi_ext.data,
                                        < double * > ebqe_kappa_phi_ext.data,
                                        < double * > ebqe_vos_ext.data,
                                        < double * > ebqe_turb_var_0.data,
                                        < double * > ebqe_turb_var_1.data,
                                        < int * > isDOFBoundary_p.data,
                                        < int * > isDOFBoundary_u.data,
                                        < int * > isDOFBoundary_v.data,
                                        < int * > isDOFBoundary_w.data,
                                        < int * > isAdvectiveFluxBoundary_p.data,
                                        < int * > isAdvectiveFluxBoundary_u.data,
                                        < int * > isAdvectiveFluxBoundary_v.data,
                                        < int * > isAdvectiveFluxBoundary_w.data,
                                        < int * > isDiffusiveFluxBoundary_u.data,
                                        < int * > isDiffusiveFluxBoundary_v.data,
                                        < int * > isDiffusiveFluxBoundary_w.data,
                                        < double * > ebqe_bc_p_ext.data,
                                        < double * > ebqe_bc_flux_mass_ext.data,
                                        < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                        < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                        < double * > ebqe_bc_flux_mom_w_adv_ext.data,
                                        < double * > ebqe_bc_u_ext.data,
                                        < double * > ebqe_bc_flux_u_diff_ext.data,
                                        < double * > ebqe_penalty_ext.data,
                                        < double * > ebqe_bc_v_ext.data,
                                        < double * > ebqe_bc_flux_v_diff_ext.data,
                                        < double * > ebqe_bc_w_ext.data,
                                        < double * > ebqe_bc_flux_w_diff_ext.data,
                                        < int * > csrColumnOffsets_eb_p_p.data,
                                        < int * > csrColumnOffsets_eb_p_u.data,
                                        < int * > csrColumnOffsets_eb_p_v.data,
                                        < int * > csrColumnOffsets_eb_p_w.data,
                                        < int * > csrColumnOffsets_eb_u_p.data,
                                        < int * > csrColumnOffsets_eb_u_u.data,
                                        < int * > csrColumnOffsets_eb_u_v.data,
                                        < int * > csrColumnOffsets_eb_u_w.data,
                                        < int * > csrColumnOffsets_eb_v_p.data,
                                        < int * > csrColumnOffsets_eb_v_u.data,
                                        < int * > csrColumnOffsets_eb_v_v.data,
                                        < int * > csrColumnOffsets_eb_v_w.data,
                                        < int * > csrColumnOffsets_eb_w_p.data,
                                        < int * > csrColumnOffsets_eb_w_u.data,
                                        < int * > csrColumnOffsets_eb_w_v.data,
                                        < int * > csrColumnOffsets_eb_w_w.data,
                                        < int * > elementFlags.data,
                                        nParticles,
                                        particle_epsFact,
                                        particle_alpha,
                                        particle_beta,
                                        particle_penalty_constant,
                                        < double * > particle_signed_distances.data,
                                        < double * > particle_signed_distance_normals.data,
                                        < double * > particle_velocities.data,
                                        < double * > particle_centroids.data,
                                        particle_nitsche,
                                        use_ball_as_particle,
                                        < double * > ball_center.data,
                                        < double * > ball_radius.data,
                                        < double * > ball_velocity.data,
                                        < double * > ball_angular_velocity.data,
                                        USE_SUPG,
                                        KILL_PRESSURE_TERM,
                                        dt,
                                        MATERIAL_PARAMETERS_AS_FUNCTION,
                                        < double * > density_as_function.data,
                                        < double * > dynamic_viscosity_as_function.data,
                                        < double * > ebqe_density_as_function.data,
                                        < double * > ebqe_dynamic_viscosity_as_function.data,
                                        USE_SBM)

    def calculateVelocityAverage(self,
                                 int nExteriorElementBoundaries_global,
                                 numpy.ndarray exteriorElementBoundariesArray,
                                 int nInteriorElementBoundaries_global,
                                 numpy.ndarray interiorElementBoundariesArray,
                                 numpy.ndarray elementBoundaryElementsArray,
                                 numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                                 numpy.ndarray mesh_dof,
                                 numpy.ndarray mesh_velocity_dof,
                                 double MOVING_DOMAIN,
                                 numpy.ndarray mesh_l2g,
                                 numpy.ndarray mesh_trial_trace_ref,
                                 numpy.ndarray mesh_grad_trial_trace_ref,
                                 numpy.ndarray normal_ref,
                                 numpy.ndarray boundaryJac_ref,
                                 numpy.ndarray vel_l2g,
                                 numpy.ndarray u_dof,
                                 numpy.ndarray v_dof,
                                 numpy.ndarray w_dof,
                                 numpy.ndarray vos_dof,
                                 numpy.ndarray vel_trial_trace_ref,
                                 numpy.ndarray ebqe_velocity,
                                 numpy.ndarray velocityAverage):
        self.thisptr.calculateVelocityAverage(nExteriorElementBoundaries_global,
                                              < int * > exteriorElementBoundariesArray.data,
                                              nInteriorElementBoundaries_global,
                                              < int * > interiorElementBoundariesArray.data,
                                              < int * > elementBoundaryElementsArray.data,
                                              < int * > elementBoundaryLocalElementBoundariesArray.data,
                                              < double * > mesh_dof.data,
                                              < double * > mesh_velocity_dof.data,
                                              MOVING_DOMAIN,
                                              < int * > mesh_l2g.data,
                                              < double * > mesh_trial_trace_ref.data,
                                              < double * > mesh_grad_trial_trace_ref.data,
                                              < double * > normal_ref.data,
                                              < double * > boundaryJac_ref.data,
                                              < int * > vel_l2g.data,
                                              < double * > u_dof.data,
                                              < double * > v_dof.data,
                                              < double * > w_dof.data,
                                              < double * > vos_dof.data,
                                              < double * > vel_trial_trace_ref.data,
                                              < double * > ebqe_velocity.data,
                                              < double * > velocityAverage.data)

