# A type of -*- python -*- file
import numpy
cimport numpy
from proteus import *
from proteus.Transport import *
from proteus.Transport import OneLevelTransport

cdef extern from "SW2D.h" namespace "proteus":
    cdef cppclass SW2D_base:
        void calculateResidual(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * h_trial_ref,
                               double * h_grad_trial_ref,
                               double * h_test_ref,
                               double * h_grad_test_ref,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * h_trial_trace_ref,
                               double * h_grad_trial_trace_ref,
                               double * h_test_trace_ref,
                               double * h_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double * elementDiameter,
                               int nElements_global,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double nu,
                               double g,
                               double shockCapturingCoefficient,
                               int * h_l2g,
                               int * vel_l2g,
                               double * b_dof,
                               double * h_dof,
                               double * u_dof,
                               double * v_dof,
                               double * h_dof_sge,
                               double * u_dof_sge,
                               double * v_dof_sge,
                               double * q_mass_acc,
                               double * q_mom_u_acc,
                               double * q_mom_v_acc,
                               double * q_mass_adv,
                               double * q_mass_acc_beta_bdf,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_velocity_sge,
                               double * q_cfl,
                               double * q_numDiff_h,
                               double * q_numDiff_u,
                               double * q_numDiff_v,
                               double * q_numDiff_h_last,
                               double * q_numDiff_u_last,
                               double * q_numDiff_v_last,
                               int * sdInfo_u_u_rowptr,
                               int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr,
                               int * sdInfo_u_v_colind,
                               int * sdInfo_v_v_rowptr,
                               int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr,
                               int * sdInfo_v_u_colind,
                               int offset_h,
                               int offset_u,
                               int offset_v,
                               int stride_h,
                               int stride_u,
                               int stride_v,
                               double * globalResidual,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               int * isDOFBoundary_h,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isAdvectiveFluxBoundary_h,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               double * ebqe_bc_h_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_henalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               double * q_velocity,
                               double * ebqe_velocity,
                               double * flux,
                               double * elementResidual_h)
        void calculateJacobian(double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * h_trial_ref,
                               double * h_grad_trial_ref,
                               double * h_test_ref,
                               double * h_grad_test_ref,
                               double * vel_trial_ref,
                               double * vel_grad_trial_ref,
                               double * vel_test_ref,
                               double * vel_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * h_trial_trace_ref,
                               double * h_grad_trial_trace_ref,
                               double * h_test_trace_ref,
                               double * h_grad_test_trace_ref,
                               double * vel_trial_trace_ref,
                               double * vel_grad_trial_trace_ref,
                               double * vel_test_trace_ref,
                               double * vel_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               double * elementDiameter,
                               int nElements_global,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double nu,
                               double g,
                               int * h_l2g,
                               int * vel_l2g,
                               double * b_dof,
                               double * h_dof,
                               double * u_dof,
                               double * v_dof,
                               double * h_dof_sge,
                               double * u_dof_sge,
                               double * v_dof_sge,
                               double * q_mass_acc_bdf,
                               double * q_mom_u_acc_beta_bdf,
                               double * q_mom_v_acc_beta_bdf,
                               double * q_velocity_sge,
                               double * q_cfl,
                               double * q_numDiff_h_last,
                               double * q_numDiff_u_last,
                               double * q_numDiff_v_last,
                               int * sdInfo_u_u_rowptr,
                               int * sdInfo_u_u_colind,
                               int * sdInfo_u_v_rowptr,
                               int * sdInfo_u_v_colind,
                               int * sdInfo_v_v_rowptr,
                               int * sdInfo_v_v_colind,
                               int * sdInfo_v_u_rowptr,
                               int * sdInfo_v_u_colind,
                               int * csrRowIndeces_h_h,
                               int * csrColumnOffsets_h_h,
                               int * csrRowIndeces_h_u,
                               int * csrColumnOffsets_h_u,
                               int * csrRowIndeces_h_v,
                               int * csrColumnOffsets_h_v,
                               int * csrRowIndeces_u_h,
                               int * csrColumnOffsets_u_h,
                               int * csrRowIndeces_u_u,
                               int * csrColumnOffsets_u_u,
                               int * csrRowIndeces_u_v,
                               int * csrColumnOffsets_u_v,
                               int * csrRowIndeces_v_h,
                               int * csrColumnOffsets_v_h,
                               int * csrRowIndeces_v_u,
                               int * csrColumnOffsets_v_u,
                               int * csrRowIndeces_v_v,
                               int * csrColumnOffsets_v_v,
                               double * globalJacobian,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               int * isDOFBoundary_h,
                               int * isDOFBoundary_u,
                               int * isDOFBoundary_v,
                               int * isAdvectiveFluxBoundary_h,
                               int * isAdvectiveFluxBoundary_u,
                               int * isAdvectiveFluxBoundary_v,
                               int * isDiffusiveFluxBoundary_u,
                               int * isDiffusiveFluxBoundary_v,
                               double * ebqe_bc_h_ext,
                               double * ebqe_bc_flux_mass_ext,
                               double * ebqe_bc_flux_mom_u_adv_ext,
                               double * ebqe_bc_flux_mom_v_adv_ext,
                               double * ebqe_bc_u_ext,
                               double * ebqe_bc_flux_u_diff_ext,
                               double * ebqe_henalty_ext,
                               double * ebqe_bc_v_ext,
                               double * ebqe_bc_flux_v_diff_ext,
                               int * csrColumnOffsets_eb_h_h,
                               int * csrColumnOffsets_eb_h_u,
                               int * csrColumnOffsets_eb_h_v,
                               int * csrColumnOffsets_eb_u_h,
                               int * csrColumnOffsets_eb_u_u,
                               int * csrColumnOffsets_eb_u_v,
                               int * csrColumnOffsets_eb_v_h,
                               int * csrColumnOffsets_eb_v_u,
                               int * csrColumnOffsets_eb_v_v)
        void calculateResidual_supg(double * mesh_trial_ref,
                                    double * mesh_grad_trial_ref,
                                    double * mesh_dof,
                                    double * mesh_velocity_dof,
                                    double MOVING_DOMAIN,
                                    int * mesh_l2g,
                                    double * dV_ref,
                                    double * h_trial_ref,
                                    double * h_grad_trial_ref,
                                    double * h_test_ref,
                                    double * h_grad_test_ref,
                                    double * vel_trial_ref,
                                    double * vel_grad_trial_ref,
                                    double * vel_test_ref,
                                    double * vel_grad_test_ref,
                                    double * mesh_trial_trace_ref,
                                    double * mesh_grad_trial_trace_ref,
                                    double * dS_ref,
                                    double * h_trial_trace_ref,
                                    double * h_grad_trial_trace_ref,
                                    double * h_test_trace_ref,
                                    double * h_grad_test_trace_ref,
                                    double * vel_trial_trace_ref,
                                    double * vel_grad_trial_trace_ref,
                                    double * vel_test_trace_ref,
                                    double * vel_grad_test_trace_ref,
                                    double * normal_ref,
                                    double * boundaryJac_ref,
                                    double * elementDiameter,
                                    int nElements_global,
                                    double useRBLES,
                                    double useMetrics,
                                    double alphaBDF,
                                    double nu,
                                    double g,
                                    double shockCapturingCoefficient,
                                    int * h_l2g,
                                    int * vel_l2g,
                                    double * b_dof,
                                    double * h_dof,
                                    double * u_dof,
                                    double * v_dof,
                                    double * h_dof_sge,
                                    double * u_dof_sge,
                                    double * v_dof_sge,
                                    double * q_mass_acc,
                                    double * q_mom_u_acc,
                                    double * q_mom_v_acc,
                                    double * q_mass_adv,
                                    double * q_mass_acc_beta_bdf,
                                    double * q_mom_u_acc_beta_bdf,
                                    double * q_mom_v_acc_beta_bdf,
                                    double * q_velocity_sge,
                                    double * q_cfl,
                                    double * q_numDiff_h,
                                    double * q_numDiff_u,
                                    double * q_numDiff_v,
                                    double * q_numDiff_h_last,
                                    double * q_numDiff_u_last,
                                    double * q_numDiff_v_last,
                                    int * sdInfo_u_u_rowptr,
                                    int * sdInfo_u_u_colind,
                                    int * sdInfo_u_v_rowptr,
                                    int * sdInfo_u_v_colind,
                                    int * sdInfo_v_v_rowptr,
                                    int * sdInfo_v_v_colind,
                                    int * sdInfo_v_u_rowptr,
                                    int * sdInfo_v_u_colind,
                                    int offset_h,
                                    int offset_u,
                                    int offset_v,
                                    int stride_h,
                                    int stride_u,
                                    int stride_v,
                                    double * globalResidual,
                                    int nExteriorElementBoundaries_global,
                                    int * exteriorElementBoundariesArray,
                                    int * elementBoundaryElementsArray,
                                    int * elementBoundaryLocalElementBoundariesArray,
                                    int * isDOFBoundary_h,
                                    int * isDOFBoundary_u,
                                    int * isDOFBoundary_v,
                                    int * isAdvectiveFluxBoundary_h,
                                    int * isAdvectiveFluxBoundary_u,
                                    int * isAdvectiveFluxBoundary_v,
                                    int * isDiffusiveFluxBoundary_u,
                                    int * isDiffusiveFluxBoundary_v,
                                    double * ebqe_bc_h_ext,
                                    double * ebqe_bc_flux_mass_ext,
                                    double * ebqe_bc_flux_mom_u_adv_ext,
                                    double * ebqe_bc_flux_mom_v_adv_ext,
                                    double * ebqe_bc_u_ext,
                                    double * ebqe_bc_flux_u_diff_ext,
                                    double * ebqe_henalty_ext,
                                    double * ebqe_bc_v_ext,
                                    double * ebqe_bc_flux_v_diff_ext,
                                    double * q_velocity,
                                    double * ebqe_velocity,
                                    double * flux,
                                    double * elementResidual_h)
        void calculateJacobian_supg(double * mesh_trial_ref,
                                    double * mesh_grad_trial_ref,
                                    double * mesh_dof,
                                    double * mesh_velocity_dof,
                                    double MOVING_DOMAIN,
                                    int * mesh_l2g,
                                    double * dV_ref,
                                    double * h_trial_ref,
                                    double * h_grad_trial_ref,
                                    double * h_test_ref,
                                    double * h_grad_test_ref,
                                    double * vel_trial_ref,
                                    double * vel_grad_trial_ref,
                                    double * vel_test_ref,
                                    double * vel_grad_test_ref,
                                    double * mesh_trial_trace_ref,
                                    double * mesh_grad_trial_trace_ref,
                                    double * dS_ref,
                                    double * h_trial_trace_ref,
                                    double * h_grad_trial_trace_ref,
                                    double * h_test_trace_ref,
                                    double * h_grad_test_trace_ref,
                                    double * vel_trial_trace_ref,
                                    double * vel_grad_trial_trace_ref,
                                    double * vel_test_trace_ref,
                                    double * vel_grad_test_trace_ref,
                                    double * normal_ref,
                                    double * boundaryJac_ref,
                                    double * elementDiameter,
                                    int nElements_global,
                                    double useRBLES,
                                    double useMetrics,
                                    double alphaBDF,
                                    double nu,
                                    double g,
                                    int * h_l2g,
                                    int * vel_l2g,
                                    double * b_dof,
                                    double * h_dof,
                                    double * u_dof,
                                    double * v_dof,
                                    double * h_dof_sge,
                                    double * u_dof_sge,
                                    double * v_dof_sge,
                                    double * q_mass_acc_bdf,
                                    double * q_mom_u_acc_beta_bdf,
                                    double * q_mom_v_acc_beta_bdf,
                                    double * q_velocity_sge,
                                    double * q_cfl,
                                    double * q_numDiff_h_last,
                                    double * q_numDiff_u_last,
                                    double * q_numDiff_v_last,
                                    int * sdInfo_u_u_rowptr,
                                    int * sdInfo_u_u_colind,
                                    int * sdInfo_u_v_rowptr,
                                    int * sdInfo_u_v_colind,
                                    int * sdInfo_v_v_rowptr,
                                    int * sdInfo_v_v_colind,
                                    int * sdInfo_v_u_rowptr,
                                    int * sdInfo_v_u_colind,
                                    int * csrRowIndeces_h_h,
                                    int * csrColumnOffsets_h_h,
                                    int * csrRowIndeces_h_u,
                                    int * csrColumnOffsets_h_u,
                                    int * csrRowIndeces_h_v,
                                    int * csrColumnOffsets_h_v,
                                    int * csrRowIndeces_u_h,
                                    int * csrColumnOffsets_u_h,
                                    int * csrRowIndeces_u_u,
                                    int * csrColumnOffsets_u_u,
                                    int * csrRowIndeces_u_v,
                                    int * csrColumnOffsets_u_v,
                                    int * csrRowIndeces_v_h,
                                    int * csrColumnOffsets_v_h,
                                    int * csrRowIndeces_v_u,
                                    int * csrColumnOffsets_v_u,
                                    int * csrRowIndeces_v_v,
                                    int * csrColumnOffsets_v_v,
                                    double * globalJacobian,
                                    int nExteriorElementBoundaries_global,
                                    int * exteriorElementBoundariesArray,
                                    int * elementBoundaryElementsArray,
                                    int * elementBoundaryLocalElementBoundariesArray,
                                    int * isDOFBoundary_h,
                                    int * isDOFBoundary_u,
                                    int * isDOFBoundary_v,
                                    int * isAdvectiveFluxBoundary_h,
                                    int * isAdvectiveFluxBoundary_u,
                                    int * isAdvectiveFluxBoundary_v,
                                    int * isDiffusiveFluxBoundary_u,
                                    int * isDiffusiveFluxBoundary_v,
                                    double * ebqe_bc_h_ext,
                                    double * ebqe_bc_flux_mass_ext,
                                    double * ebqe_bc_flux_mom_u_adv_ext,
                                    double * ebqe_bc_flux_mom_v_adv_ext,
                                    double * ebqe_bc_u_ext,
                                    double * ebqe_bc_flux_u_diff_ext,
                                    double * ebqe_henalty_ext,
                                    double * ebqe_bc_v_ext,
                                    double * ebqe_bc_flux_v_diff_ext,
                                    int * csrColumnOffsets_eb_h_h,
                                    int * csrColumnOffsets_eb_h_u,
                                    int * csrColumnOffsets_eb_h_v,
                                    int * csrColumnOffsets_eb_u_h,
                                    int * csrColumnOffsets_eb_u_u,
                                    int * csrColumnOffsets_eb_u_v,
                                    int * csrColumnOffsets_eb_v_h,
                                    int * csrColumnOffsets_eb_v_u,
                                    int * csrColumnOffsets_eb_v_v)
    SW2D_base * newSW2D(int nSpaceIn,
                        int nQuadraturePoints_elementIn,
                        int nDOF_mesh_trial_elementIn,
                        int nDOF_trial_elementIn,
                        int nDOF_test_elementIn,
                        int nQuadraturePoints_elementBoundaryIn,
                        int CompKernelFlag)

cdef class cSW2D_base:
    cdef SW2D_base * thisptr

    def __cinit__(self,
                  int nSpaceIn,
                  int nQuadraturePoints_elementIn,
                  int nDOF_mesh_trial_elementIn,
                  int nDOF_trial_elementIn,
                  int nDOF_test_elementIn,
                  int nQuadraturePoints_elementBoundaryIn,
                  int CompKernelFlag):
        self.thisptr = newSW2D(nSpaceIn,
                               nQuadraturePoints_elementIn,
                               nDOF_mesh_trial_elementIn,
                               nDOF_trial_elementIn,
                               nDOF_test_elementIn,
                               nQuadraturePoints_elementBoundaryIn,
                               CompKernelFlag)

    def __dealloc__(self):
        del self.thisptr

    def calculateResidual(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray h_trial_ref,
                          numpy.ndarray h_grad_trial_ref,
                          numpy.ndarray h_test_ref,
                          numpy.ndarray h_grad_test_ref,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray h_trial_trace_ref,
                          numpy.ndarray h_grad_trial_trace_ref,
                          numpy.ndarray h_test_trace_ref,
                          numpy.ndarray h_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          numpy.ndarray elementDiameter,
                          int nElements_global,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double nu,
                          double g,
                          double shockCapturingCoefficient,
                          numpy.ndarray h_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray b_dof,
                          numpy.ndarray h_dof,
                          numpy.ndarray u_dof,
                          numpy.ndarray v_dof,
                          numpy.ndarray h_dof_sge,
                          numpy.ndarray u_dof_sge,
                          numpy.ndarray v_dof_sge,
                          numpy.ndarray q_mass_acc,
                          numpy.ndarray q_mom_u_acc,
                          numpy.ndarray q_mom_v_acc,
                          numpy.ndarray q_mass_adv,
                          numpy.ndarray q_mass_acc_beta_bdf,
                          numpy.ndarray q_mom_u_acc_beta_bdf,
                          numpy.ndarray q_mom_v_acc_beta_bdf,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_h,
                          numpy.ndarray q_numDiff_u,
                          numpy.ndarray q_numDiff_v,
                          numpy.ndarray q_numDiff_h_last,
                          numpy.ndarray q_numDiff_u_last,
                          numpy.ndarray q_numDiff_v_last,
                          numpy.ndarray sdInfo_u_u_rowptr,
                          numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr,
                          numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_v_v_rowptr,
                          numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr,
                          numpy.ndarray sdInfo_v_u_colind,
                          int offset_h,
                          int offset_u,
                          int offset_v,
                          int stride_h,
                          int stride_u,
                          int stride_v,
                          numpy.ndarray globalResidual,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray isDOFBoundary_h,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_h,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray ebqe_bc_h_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_henalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray q_velocity,
                          numpy.ndarray ebqe_velocity,
                          numpy.ndarray flux,
                          numpy.ndarray elementResidual_h):
        self.thisptr.calculateResidual(  # element
            < double * > mesh_trial_ref.data,
            < double * > mesh_grad_trial_ref.data,
            < double * > mesh_dof.data,
            < double * > mesh_velocity_dof.data,
            MOVING_DOMAIN,
            < int * > mesh_l2g.data,
            < double * > dV_ref.data,
            < double * > h_trial_ref.data,
            < double * > h_grad_trial_ref.data,
            < double * > h_test_ref.data,
            < double * > h_grad_test_ref.data,
            < double * > vel_trial_ref.data,
            < double * > vel_grad_trial_ref.data,
            < double * > vel_test_ref.data,
            < double * > vel_grad_test_ref.data,
            # element boundary
            < double * > mesh_trial_trace_ref.data,
            < double * > mesh_grad_trial_trace_ref.data,
            < double * > dS_ref.data,
            < double * > h_trial_trace_ref.data,
            < double * > h_grad_trial_trace_ref.data,
            < double * > h_test_trace_ref.data,
            < double * > h_grad_test_trace_ref.data,
            < double * > vel_trial_trace_ref.data,
            < double * > vel_grad_trial_trace_ref.data,
            < double * > vel_test_trace_ref.data,
            < double * > vel_grad_test_trace_ref.data,
            < double * > normal_ref.data,
            < double * > boundaryJac_ref.data,
            # physics
            < double * > elementDiameter.data,
            nElements_global,
            useRBLES,
            useMetrics,
            alphaBDF,
            nu,
            g,
            shockCapturingCoefficient,
            < int * > h_l2g.data,
            < int * > vel_l2g.data,
            < double * > b_dof.data,
            < double * > h_dof.data,
            < double * > u_dof.data,
            < double * > v_dof.data,
            < double * > h_dof_sge.data,
            < double * > u_dof_sge.data,
            < double * > v_dof_sge.data,
            < double * > q_mass_acc.data,
            < double * > q_mom_u_acc.data,
            < double * > q_mom_v_acc.data,
            < double * > q_mass_adv.data,
            < double * > q_mass_acc_beta_bdf.data,
            < double * > q_mom_u_acc_beta_bdf.data,
            < double * > q_mom_v_acc_beta_bdf.data,
            < double * > q_velocity_sge.data,
            < double * > q_cfl.data,
            < double * > q_numDiff_h.data,
            < double * > q_numDiff_u.data,
            < double * > q_numDiff_v.data,
            < double * > q_numDiff_h_last.data,
            < double * > q_numDiff_u_last.data,
            < double * > q_numDiff_v_last.data,
            < int * > sdInfo_u_u_rowptr.data,
            < int * > sdInfo_u_u_colind.data,
            < int * > sdInfo_u_v_rowptr.data,
            < int * > sdInfo_u_v_colind.data,
            < int * > sdInfo_v_v_rowptr.data,
            < int * > sdInfo_v_v_colind.data,
            < int * > sdInfo_v_u_rowptr.data,
            < int * > sdInfo_v_u_colind.data,
            offset_h,
            offset_u,
            offset_v,
            stride_h,
            stride_u,
            stride_v,
            < double * > globalResidual.data,
            nExteriorElementBoundaries_global,
            < int * > exteriorElementBoundariesArray.data,
            < int * > elementBoundaryElementsArray.data,
            < int * > elementBoundaryLocalElementBoundariesArray.data,
            < int * > isDOFBoundary_h.data,
            < int * > isDOFBoundary_u.data,
            < int * > isDOFBoundary_v.data,
            < int * > isAdvectiveFluxBoundary_h.data,
            < int * > isAdvectiveFluxBoundary_u.data,
            < int * > isAdvectiveFluxBoundary_v.data,
            < int * > isDiffusiveFluxBoundary_u.data,
            < int * > isDiffusiveFluxBoundary_v.data,
            < double * > ebqe_bc_h_ext.data,
            < double * > ebqe_bc_flux_mass_ext.data,
            < double * > ebqe_bc_flux_mom_u_adv_ext.data,
            < double * > ebqe_bc_flux_mom_v_adv_ext.data,
            < double * > ebqe_bc_u_ext.data,
            < double * > ebqe_bc_flux_u_diff_ext.data,
            < double * > ebqe_henalty_ext.data,
            < double * > ebqe_bc_v_ext.data,
            < double * > ebqe_bc_flux_v_diff_ext.data,
            < double * > q_velocity.data,
            < double * > ebqe_velocity.data,
            < double * > flux.data,
            < double * > elementResidual_h.data)

    def calculateJacobian(self,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray h_trial_ref,
                          numpy.ndarray h_grad_trial_ref,
                          numpy.ndarray h_test_ref,
                          numpy.ndarray h_grad_test_ref,
                          numpy.ndarray vel_trial_ref,
                          numpy.ndarray vel_grad_trial_ref,
                          numpy.ndarray vel_test_ref,
                          numpy.ndarray vel_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray h_trial_trace_ref,
                          numpy.ndarray h_grad_trial_trace_ref,
                          numpy.ndarray h_test_trace_ref,
                          numpy.ndarray h_grad_test_trace_ref,
                          numpy.ndarray vel_trial_trace_ref,
                          numpy.ndarray vel_grad_trial_trace_ref,
                          numpy.ndarray vel_test_trace_ref,
                          numpy.ndarray vel_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          numpy.ndarray elementDiameter,
                          int nElements_global,
                          double useRBLES,
                          double useMetrics,
                          double alphaBDF,
                          double nu,
                          double g,
                          numpy.ndarray h_l2g,
                          numpy.ndarray vel_l2g,
                          numpy.ndarray b_dof,
                          numpy.ndarray h_dof,
                          numpy.ndarray u_dof,
                          numpy.ndarray v_dof,
                          numpy.ndarray h_dof_sge,
                          numpy.ndarray u_dof_sge,
                          numpy.ndarray v_dof_sge,
                          numpy.ndarray q_mass_acc_beta_bdf,
                          numpy.ndarray q_mom_u_acc_beta_bdf,
                          numpy.ndarray q_mom_v_acc_beta_bdf,
                          numpy.ndarray q_velocity_sge,
                          numpy.ndarray q_cfl,
                          numpy.ndarray q_numDiff_h_last,
                          numpy.ndarray q_numDiff_u_last,
                          numpy.ndarray q_numDiff_v_last,
                          numpy.ndarray sdInfo_u_u_rowptr,
                          numpy.ndarray sdInfo_u_u_colind,
                          numpy.ndarray sdInfo_u_v_rowptr,
                          numpy.ndarray sdInfo_u_v_colind,
                          numpy.ndarray sdInfo_v_v_rowptr,
                          numpy.ndarray sdInfo_v_v_colind,
                          numpy.ndarray sdInfo_v_u_rowptr,
                          numpy.ndarray sdInfo_v_u_colind,
                          numpy.ndarray csrRowIndeces_h_h,
                          numpy.ndarray csrColumnOffsets_h_h,
                          numpy.ndarray csrRowIndeces_h_u,
                          numpy.ndarray csrColumnOffsets_h_u,
                          numpy.ndarray csrRowIndeces_h_v,
                          numpy.ndarray csrColumnOffsets_h_v,
                          numpy.ndarray csrRowIndeces_u_h,
                          numpy.ndarray csrColumnOffsets_u_h,
                          numpy.ndarray csrRowIndeces_u_u,
                          numpy.ndarray csrColumnOffsets_u_u,
                          numpy.ndarray csrRowIndeces_u_v,
                          numpy.ndarray csrColumnOffsets_u_v,
                          numpy.ndarray csrRowIndeces_v_h,
                          numpy.ndarray csrColumnOffsets_v_h,
                          numpy.ndarray csrRowIndeces_v_u,
                          numpy.ndarray csrColumnOffsets_v_u,
                          numpy.ndarray csrRowIndeces_v_v,
                          numpy.ndarray csrColumnOffsets_v_v,
                          globalJacobian,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray isDOFBoundary_h,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray isDOFBoundary_v,
                          numpy.ndarray isAdvectiveFluxBoundary_h,
                          numpy.ndarray isAdvectiveFluxBoundary_u,
                          numpy.ndarray isAdvectiveFluxBoundary_v,
                          numpy.ndarray isDiffusiveFluxBoundary_u,
                          numpy.ndarray isDiffusiveFluxBoundary_v,
                          numpy.ndarray ebqe_bc_h_ext,
                          numpy.ndarray ebqe_bc_flux_mass_ext,
                          numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                          numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray ebqe_bc_flux_u_diff_ext,
                          numpy.ndarray ebqe_henalty_ext,
                          numpy.ndarray ebqe_bc_v_ext,
                          numpy.ndarray ebqe_bc_flux_v_diff_ext,
                          numpy.ndarray csrColumnOffsets_eb_h_h,
                          numpy.ndarray csrColumnOffsets_eb_h_u,
                          numpy.ndarray csrColumnOffsets_eb_h_v,
                          numpy.ndarray csrColumnOffsets_eb_u_h,
                          numpy.ndarray csrColumnOffsets_eb_u_u,
                          numpy.ndarray csrColumnOffsets_eb_u_v,
                          numpy.ndarray csrColumnOffsets_eb_v_h,
                          numpy.ndarray csrColumnOffsets_eb_v_u,
                          numpy.ndarray csrColumnOffsets_eb_v_v):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateJacobian(< double*> mesh_trial_ref.data,
                                        < double * > mesh_grad_trial_ref.data,
                                        < double * > mesh_dof.data,
                                        < double * > mesh_velocity_dof.data,
                                        MOVING_DOMAIN,
                                        < int * > mesh_l2g.data,
                                        < double * > dV_ref.data,
                                        < double * > h_trial_ref.data,
                                        < double * > h_grad_trial_ref.data,
                                        < double * > h_test_ref.data,
                                        < double * > h_grad_test_ref.data,
                                        < double * > vel_trial_ref.data,
                                        < double * > vel_grad_trial_ref.data,
                                        < double * > vel_test_ref.data,
                                        < double * > vel_grad_test_ref.data,
                                        < double * > mesh_trial_trace_ref.data,
                                        < double * > mesh_grad_trial_trace_ref.data,
                                        < double * > dS_ref.data,
                                        < double * > h_trial_trace_ref.data,
                                        < double * > h_grad_trial_trace_ref.data,
                                        < double * > h_test_trace_ref.data,
                                        < double * > h_grad_test_trace_ref.data,
                                        < double * > vel_trial_trace_ref.data,
                                        < double * > vel_grad_trial_trace_ref.data,
                                        < double * > vel_test_trace_ref.data,
                                        < double * > vel_grad_test_trace_ref.data,
                                        < double * > normal_ref.data,
                                        < double * > boundaryJac_ref.data,
                                        < double * > elementDiameter.data,
                                        nElements_global,
                                        useRBLES,
                                        useMetrics,
                                        alphaBDF,
                                        nu,
                                        g,
                                        < int * > h_l2g.data,
                                        < int * > vel_l2g.data,
                                        < double * > b_dof.data,
                                        < double * > h_dof.data,
                                        < double * > u_dof.data,
                                        < double * > v_dof.data,
                                        < double * > h_dof_sge.data,
                                        < double * > u_dof_sge.data,
                                        < double * > v_dof_sge.data,
                                        < double * > q_mass_acc_beta_bdf.data,
                                        < double * > q_mom_u_acc_beta_bdf.data,
                                        < double * > q_mom_v_acc_beta_bdf.data,
                                        < double * > q_velocity_sge.data,
                                        < double * > q_cfl.data,
                                        < double * > q_numDiff_h_last.data,
                                        < double * > q_numDiff_u_last.data,
                                        < double * > q_numDiff_v_last.data,
                                        < int * > sdInfo_u_u_rowptr.data,
                                        < int * > sdInfo_u_u_colind.data,
                                        < int * > sdInfo_u_v_rowptr.data,
                                        < int * > sdInfo_u_v_colind.data,
                                        < int * > sdInfo_v_v_rowptr.data,
                                        < int * > sdInfo_v_v_colind.data,
                                        < int * > sdInfo_v_u_rowptr.data,
                                        < int * > sdInfo_v_u_colind.data,
                                        < int * > csrRowIndeces_h_h.data,
                                        < int * > csrColumnOffsets_h_h.data,
                                        < int * > csrRowIndeces_h_u.data,
                                        < int * > csrColumnOffsets_h_u.data,
                                        < int * > csrRowIndeces_h_v.data,
                                        < int * > csrColumnOffsets_h_v.data,
                                        < int * > csrRowIndeces_u_h.data,
                                        < int * > csrColumnOffsets_u_h.data,
                                        < int * > csrRowIndeces_u_u.data,
                                        < int * > csrColumnOffsets_u_u.data,
                                        < int * > csrRowIndeces_u_v.data,
                                        < int * > csrColumnOffsets_u_v.data,
                                        < int * > csrRowIndeces_v_h.data,
                                        < int * > csrColumnOffsets_v_h.data,
                                        < int * > csrRowIndeces_v_u.data,
                                        < int * > csrColumnOffsets_v_u.data,
                                        < int * > csrRowIndeces_v_v.data,
                                        < int * > csrColumnOffsets_v_v.data,
                                        < double * > globalJacobian_a.data,
                                        nExteriorElementBoundaries_global,
                                        < int * > exteriorElementBoundariesArray.data,
                                        < int * > elementBoundaryElementsArray.data,
                                        < int * > elementBoundaryLocalElementBoundariesArray.data,
                                        < int * > isDOFBoundary_h.data,
                                        < int * > isDOFBoundary_u.data,
                                        < int * > isDOFBoundary_v.data,
                                        < int * > isAdvectiveFluxBoundary_h.data,
                                        < int * > isAdvectiveFluxBoundary_u.data,
                                        < int * > isAdvectiveFluxBoundary_v.data,
                                        < int * > isDiffusiveFluxBoundary_u.data,
                                        < int * > isDiffusiveFluxBoundary_v.data,
                                        < double * > ebqe_bc_h_ext.data,
                                        < double * > ebqe_bc_flux_mass_ext.data,
                                        < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                        < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                        < double * > ebqe_bc_u_ext.data,
                                        < double * > ebqe_bc_flux_u_diff_ext.data,
                                        < double * > ebqe_henalty_ext.data,
                                        < double * > ebqe_bc_v_ext.data,
                                        < double * > ebqe_bc_flux_v_diff_ext.data,
                                        < int * > csrColumnOffsets_eb_h_h.data,
                                        < int * > csrColumnOffsets_eb_h_u.data,
                                        < int * > csrColumnOffsets_eb_h_v.data,
                                        < int * > csrColumnOffsets_eb_u_h.data,
                                        < int * > csrColumnOffsets_eb_u_u.data,
                                        < int * > csrColumnOffsets_eb_u_v.data,
                                        < int * > csrColumnOffsets_eb_v_h.data,
                                        < int * > csrColumnOffsets_eb_v_u.data,
                                        < int * > csrColumnOffsets_eb_v_v.data)

    def calculateResidual_supg(self,
                               numpy.ndarray mesh_trial_ref,
                               numpy.ndarray mesh_grad_trial_ref,
                               numpy.ndarray mesh_dof,
                               numpy.ndarray mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               numpy.ndarray mesh_l2g,
                               numpy.ndarray dV_ref,
                               numpy.ndarray h_trial_ref,
                               numpy.ndarray h_grad_trial_ref,
                               numpy.ndarray h_test_ref,
                               numpy.ndarray h_grad_test_ref,
                               numpy.ndarray vel_trial_ref,
                               numpy.ndarray vel_grad_trial_ref,
                               numpy.ndarray vel_test_ref,
                               numpy.ndarray vel_grad_test_ref,
                               numpy.ndarray mesh_trial_trace_ref,
                               numpy.ndarray mesh_grad_trial_trace_ref,
                               numpy.ndarray dS_ref,
                               numpy.ndarray h_trial_trace_ref,
                               numpy.ndarray h_grad_trial_trace_ref,
                               numpy.ndarray h_test_trace_ref,
                               numpy.ndarray h_grad_test_trace_ref,
                               numpy.ndarray vel_trial_trace_ref,
                               numpy.ndarray vel_grad_trial_trace_ref,
                               numpy.ndarray vel_test_trace_ref,
                               numpy.ndarray vel_grad_test_trace_ref,
                               numpy.ndarray normal_ref,
                               numpy.ndarray boundaryJac_ref,
                               numpy.ndarray elementDiameter,
                               int nElements_global,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double nu,
                               double g,
                               double shockCapturingCoefficient,
                               numpy.ndarray h_l2g,
                               numpy.ndarray vel_l2g,
                               numpy.ndarray b_dof,
                               numpy.ndarray h_dof,
                               numpy.ndarray u_dof,
                               numpy.ndarray v_dof,
                               numpy.ndarray h_dof_sge,
                               numpy.ndarray u_dof_sge,
                               numpy.ndarray v_dof_sge,
                               numpy.ndarray q_mass_acc,
                               numpy.ndarray q_mom_u_acc,
                               numpy.ndarray q_mom_v_acc,
                               numpy.ndarray q_mass_adv,
                               numpy.ndarray q_mass_acc_beta_bdf,
                               numpy.ndarray q_mom_u_acc_beta_bdf,
                               numpy.ndarray q_mom_v_acc_beta_bdf,
                               numpy.ndarray q_velocity_sge,
                               numpy.ndarray q_cfl,
                               numpy.ndarray q_numDiff_h,
                               numpy.ndarray q_numDiff_u,
                               numpy.ndarray q_numDiff_v,
                               numpy.ndarray q_numDiff_h_last,
                               numpy.ndarray q_numDiff_u_last,
                               numpy.ndarray q_numDiff_v_last,
                               numpy.ndarray sdInfo_u_u_rowptr,
                               numpy.ndarray sdInfo_u_u_colind,
                               numpy.ndarray sdInfo_u_v_rowptr,
                               numpy.ndarray sdInfo_u_v_colind,
                               numpy.ndarray sdInfo_v_v_rowptr,
                               numpy.ndarray sdInfo_v_v_colind,
                               numpy.ndarray sdInfo_v_u_rowptr,
                               numpy.ndarray sdInfo_v_u_colind,
                               int offset_h,
                               int offset_u,
                               int offset_v,
                               int stride_h,
                               int stride_u,
                               int stride_v,
                               numpy.ndarray globalResidual,
                               int nExteriorElementBoundaries_global,
                               numpy.ndarray exteriorElementBoundariesArray,
                               numpy.ndarray elementBoundaryElementsArray,
                               numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                               numpy.ndarray isDOFBoundary_h,
                               numpy.ndarray isDOFBoundary_u,
                               numpy.ndarray isDOFBoundary_v,
                               numpy.ndarray isAdvectiveFluxBoundary_h,
                               numpy.ndarray isAdvectiveFluxBoundary_u,
                               numpy.ndarray isAdvectiveFluxBoundary_v,
                               numpy.ndarray isDiffusiveFluxBoundary_u,
                               numpy.ndarray isDiffusiveFluxBoundary_v,
                               numpy.ndarray ebqe_bc_h_ext,
                               numpy.ndarray ebqe_bc_flux_mass_ext,
                               numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                               numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                               numpy.ndarray ebqe_bc_u_ext,
                               numpy.ndarray ebqe_bc_flux_u_diff_ext,
                               numpy.ndarray ebqe_henalty_ext,
                               numpy.ndarray ebqe_bc_v_ext,
                               numpy.ndarray ebqe_bc_flux_v_diff_ext,
                               numpy.ndarray q_velocity,
                               numpy.ndarray ebqe_velocity,
                               numpy.ndarray flux,
                               numpy.ndarray elementResidual_h):
        self.thisptr.calculateResidual_supg(  # element
            < double * > mesh_trial_ref.data,
            < double * > mesh_grad_trial_ref.data,
            < double * > mesh_dof.data,
            < double * > mesh_velocity_dof.data,
            MOVING_DOMAIN,
            < int * > mesh_l2g.data,
            < double * > dV_ref.data,
            < double * > h_trial_ref.data,
            < double * > h_grad_trial_ref.data,
            < double * > h_test_ref.data,
            < double * > h_grad_test_ref.data,
            < double * > vel_trial_ref.data,
            < double * > vel_grad_trial_ref.data,
            < double * > vel_test_ref.data,
            < double * > vel_grad_test_ref.data,
            # element boundary
            < double * > mesh_trial_trace_ref.data,
            < double * > mesh_grad_trial_trace_ref.data,
            < double * > dS_ref.data,
            < double * > h_trial_trace_ref.data,
            < double * > h_grad_trial_trace_ref.data,
            < double * > h_test_trace_ref.data,
            < double * > h_grad_test_trace_ref.data,
            < double * > vel_trial_trace_ref.data,
            < double * > vel_grad_trial_trace_ref.data,
            < double * > vel_test_trace_ref.data,
            < double * > vel_grad_test_trace_ref.data,
            < double * > normal_ref.data,
            < double * > boundaryJac_ref.data,
            # physics
            < double * > elementDiameter.data,
            nElements_global,
            useRBLES,
            useMetrics,
            alphaBDF,
            nu,
            g,
            shockCapturingCoefficient,
            < int * > h_l2g.data,
            < int * > vel_l2g.data,
            < double * > b_dof.data,
            < double * > h_dof.data,
            < double * > u_dof.data,
            < double * > v_dof.data,
            < double * > h_dof_sge.data,
            < double * > u_dof_sge.data,
            < double * > v_dof_sge.data,
            < double * > q_mass_acc.data,
            < double * > q_mom_u_acc.data,
            < double * > q_mom_v_acc.data,
            < double * > q_mass_adv.data,
            < double * > q_mass_acc_beta_bdf.data,
            < double * > q_mom_u_acc_beta_bdf.data,
            < double * > q_mom_v_acc_beta_bdf.data,
            < double * > q_velocity_sge.data,
            < double * > q_cfl.data,
            < double * > q_numDiff_h.data,
            < double * > q_numDiff_u.data,
            < double * > q_numDiff_v.data,
            < double * > q_numDiff_h_last.data,
            < double * > q_numDiff_u_last.data,
            < double * > q_numDiff_v_last.data,
            < int * > sdInfo_u_u_rowptr.data,
            < int * > sdInfo_u_u_colind.data,
            < int * > sdInfo_u_v_rowptr.data,
            < int * > sdInfo_u_v_colind.data,
            < int * > sdInfo_v_v_rowptr.data,
            < int * > sdInfo_v_v_colind.data,
            < int * > sdInfo_v_u_rowptr.data,
            < int * > sdInfo_v_u_colind.data,
            offset_h,
            offset_u,
            offset_v,
            stride_h,
            stride_u,
            stride_v,
            < double * > globalResidual.data,
            nExteriorElementBoundaries_global,
            < int * > exteriorElementBoundariesArray.data,
            < int * > elementBoundaryElementsArray.data,
            < int * > elementBoundaryLocalElementBoundariesArray.data,
            < int * > isDOFBoundary_h.data,
            < int * > isDOFBoundary_u.data,
            < int * > isDOFBoundary_v.data,
            < int * > isAdvectiveFluxBoundary_h.data,
            < int * > isAdvectiveFluxBoundary_u.data,
            < int * > isAdvectiveFluxBoundary_v.data,
            < int * > isDiffusiveFluxBoundary_u.data,
            < int * > isDiffusiveFluxBoundary_v.data,
            < double * > ebqe_bc_h_ext.data,
            < double * > ebqe_bc_flux_mass_ext.data,
            < double * > ebqe_bc_flux_mom_u_adv_ext.data,
            < double * > ebqe_bc_flux_mom_v_adv_ext.data,
            < double * > ebqe_bc_u_ext.data,
            < double * > ebqe_bc_flux_u_diff_ext.data,
            < double * > ebqe_henalty_ext.data,
            < double * > ebqe_bc_v_ext.data,
            < double * > ebqe_bc_flux_v_diff_ext.data,
            < double * > q_velocity.data,
            < double * > ebqe_velocity.data,
            < double * > flux.data,
            < double * > elementResidual_h.data)

    def calculateJacobian_supg(self,
                               numpy.ndarray mesh_trial_ref,
                               numpy.ndarray mesh_grad_trial_ref,
                               numpy.ndarray mesh_dof,
                               numpy.ndarray mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               numpy.ndarray mesh_l2g,
                               numpy.ndarray dV_ref,
                               numpy.ndarray h_trial_ref,
                               numpy.ndarray h_grad_trial_ref,
                               numpy.ndarray h_test_ref,
                               numpy.ndarray h_grad_test_ref,
                               numpy.ndarray vel_trial_ref,
                               numpy.ndarray vel_grad_trial_ref,
                               numpy.ndarray vel_test_ref,
                               numpy.ndarray vel_grad_test_ref,
                               numpy.ndarray mesh_trial_trace_ref,
                               numpy.ndarray mesh_grad_trial_trace_ref,
                               numpy.ndarray dS_ref,
                               numpy.ndarray h_trial_trace_ref,
                               numpy.ndarray h_grad_trial_trace_ref,
                               numpy.ndarray h_test_trace_ref,
                               numpy.ndarray h_grad_test_trace_ref,
                               numpy.ndarray vel_trial_trace_ref,
                               numpy.ndarray vel_grad_trial_trace_ref,
                               numpy.ndarray vel_test_trace_ref,
                               numpy.ndarray vel_grad_test_trace_ref,
                               numpy.ndarray normal_ref,
                               numpy.ndarray boundaryJac_ref,
                               numpy.ndarray elementDiameter,
                               int nElements_global,
                               double useRBLES,
                               double useMetrics,
                               double alphaBDF,
                               double nu,
                               double g,
                               numpy.ndarray h_l2g,
                               numpy.ndarray vel_l2g,
                               numpy.ndarray b_dof,
                               numpy.ndarray h_dof,
                               numpy.ndarray u_dof,
                               numpy.ndarray v_dof,
                               numpy.ndarray h_dof_sge,
                               numpy.ndarray u_dof_sge,
                               numpy.ndarray v_dof_sge,
                               numpy.ndarray q_mass_acc_beta_bdf,
                               numpy.ndarray q_mom_u_acc_beta_bdf,
                               numpy.ndarray q_mom_v_acc_beta_bdf,
                               numpy.ndarray q_velocity_sge,
                               numpy.ndarray q_cfl,
                               numpy.ndarray q_numDiff_h_last,
                               numpy.ndarray q_numDiff_u_last,
                               numpy.ndarray q_numDiff_v_last,
                               numpy.ndarray sdInfo_u_u_rowptr,
                               numpy.ndarray sdInfo_u_u_colind,
                               numpy.ndarray sdInfo_u_v_rowptr,
                               numpy.ndarray sdInfo_u_v_colind,
                               numpy.ndarray sdInfo_v_v_rowptr,
                               numpy.ndarray sdInfo_v_v_colind,
                               numpy.ndarray sdInfo_v_u_rowptr,
                               numpy.ndarray sdInfo_v_u_colind,
                               numpy.ndarray csrRowIndeces_h_h,
                               numpy.ndarray csrColumnOffsets_h_h,
                               numpy.ndarray csrRowIndeces_h_u,
                               numpy.ndarray csrColumnOffsets_h_u,
                               numpy.ndarray csrRowIndeces_h_v,
                               numpy.ndarray csrColumnOffsets_h_v,
                               numpy.ndarray csrRowIndeces_u_h,
                               numpy.ndarray csrColumnOffsets_u_h,
                               numpy.ndarray csrRowIndeces_u_u,
                               numpy.ndarray csrColumnOffsets_u_u,
                               numpy.ndarray csrRowIndeces_u_v,
                               numpy.ndarray csrColumnOffsets_u_v,
                               numpy.ndarray csrRowIndeces_v_h,
                               numpy.ndarray csrColumnOffsets_v_h,
                               numpy.ndarray csrRowIndeces_v_u,
                               numpy.ndarray csrColumnOffsets_v_u,
                               numpy.ndarray csrRowIndeces_v_v,
                               numpy.ndarray csrColumnOffsets_v_v,
                               globalJacobian,
                               int nExteriorElementBoundaries_global,
                               numpy.ndarray exteriorElementBoundariesArray,
                               numpy.ndarray elementBoundaryElementsArray,
                               numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                               numpy.ndarray isDOFBoundary_h,
                               numpy.ndarray isDOFBoundary_u,
                               numpy.ndarray isDOFBoundary_v,
                               numpy.ndarray isAdvectiveFluxBoundary_h,
                               numpy.ndarray isAdvectiveFluxBoundary_u,
                               numpy.ndarray isAdvectiveFluxBoundary_v,
                               numpy.ndarray isDiffusiveFluxBoundary_u,
                               numpy.ndarray isDiffusiveFluxBoundary_v,
                               numpy.ndarray ebqe_bc_h_ext,
                               numpy.ndarray ebqe_bc_flux_mass_ext,
                               numpy.ndarray ebqe_bc_flux_mom_u_adv_ext,
                               numpy.ndarray ebqe_bc_flux_mom_v_adv_ext,
                               numpy.ndarray ebqe_bc_u_ext,
                               numpy.ndarray ebqe_bc_flux_u_diff_ext,
                               numpy.ndarray ebqe_henalty_ext,
                               numpy.ndarray ebqe_bc_v_ext,
                               numpy.ndarray ebqe_bc_flux_v_diff_ext,
                               numpy.ndarray csrColumnOffsets_eb_h_h,
                               numpy.ndarray csrColumnOffsets_eb_h_u,
                               numpy.ndarray csrColumnOffsets_eb_h_v,
                               numpy.ndarray csrColumnOffsets_eb_u_h,
                               numpy.ndarray csrColumnOffsets_eb_u_u,
                               numpy.ndarray csrColumnOffsets_eb_u_v,
                               numpy.ndarray csrColumnOffsets_eb_v_h,
                               numpy.ndarray csrColumnOffsets_eb_v_u,
                               numpy.ndarray csrColumnOffsets_eb_v_v):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateJacobian_supg(< double*> mesh_trial_ref.data,
                                             < double * > mesh_grad_trial_ref.data,
                                             < double * > mesh_dof.data,
                                             < double * > mesh_velocity_dof.data,
                                             MOVING_DOMAIN,
                                             < int * > mesh_l2g.data,
                                             < double * > dV_ref.data,
                                             < double * > h_trial_ref.data,
                                             < double * > h_grad_trial_ref.data,
                                             < double * > h_test_ref.data,
                                             < double * > h_grad_test_ref.data,
                                             < double * > vel_trial_ref.data,
                                             < double * > vel_grad_trial_ref.data,
                                             < double * > vel_test_ref.data,
                                             < double * > vel_grad_test_ref.data,
                                             < double * > mesh_trial_trace_ref.data,
                                             < double * > mesh_grad_trial_trace_ref.data,
                                             < double * > dS_ref.data,
                                             < double * > h_trial_trace_ref.data,
                                             < double * > h_grad_trial_trace_ref.data,
                                             < double * > h_test_trace_ref.data,
                                             < double * > h_grad_test_trace_ref.data,
                                             < double * > vel_trial_trace_ref.data,
                                             < double * > vel_grad_trial_trace_ref.data,
                                             < double * > vel_test_trace_ref.data,
                                             < double * > vel_grad_test_trace_ref.data,
                                             < double * > normal_ref.data,
                                             < double * > boundaryJac_ref.data,
                                             < double * > elementDiameter.data,
                                             nElements_global,
                                             useRBLES,
                                             useMetrics,
                                             alphaBDF,
                                             nu,
                                             g,
                                             < int * > h_l2g.data,
                                             < int * > vel_l2g.data,
                                             < double * > b_dof.data,
                                             < double * > h_dof.data,
                                             < double * > u_dof.data,
                                             < double * > v_dof.data,
                                             < double * > h_dof_sge.data,
                                             < double * > u_dof_sge.data,
                                             < double * > v_dof_sge.data,
                                             < double * > q_mass_acc_beta_bdf.data,
                                             < double * > q_mom_u_acc_beta_bdf.data,
                                             < double * > q_mom_v_acc_beta_bdf.data,
                                             < double * > q_velocity_sge.data,
                                             < double * > q_cfl.data,
                                             < double * > q_numDiff_h_last.data,
                                             < double * > q_numDiff_u_last.data,
                                             < double * > q_numDiff_v_last.data,
                                             < int * > sdInfo_u_u_rowptr.data,
                                             < int * > sdInfo_u_u_colind.data,
                                             < int * > sdInfo_u_v_rowptr.data,
                                             < int * > sdInfo_u_v_colind.data,
                                             < int * > sdInfo_v_v_rowptr.data,
                                             < int * > sdInfo_v_v_colind.data,
                                             < int * > sdInfo_v_u_rowptr.data,
                                             < int * > sdInfo_v_u_colind.data,
                                             < int * > csrRowIndeces_h_h.data,
                                             < int * > csrColumnOffsets_h_h.data,
                                             < int * > csrRowIndeces_h_u.data,
                                             < int * > csrColumnOffsets_h_u.data,
                                             < int * > csrRowIndeces_h_v.data,
                                             < int * > csrColumnOffsets_h_v.data,
                                             < int * > csrRowIndeces_u_h.data,
                                             < int * > csrColumnOffsets_u_h.data,
                                             < int * > csrRowIndeces_u_u.data,
                                             < int * > csrColumnOffsets_u_u.data,
                                             < int * > csrRowIndeces_u_v.data,
                                             < int * > csrColumnOffsets_u_v.data,
                                             < int * > csrRowIndeces_v_h.data,
                                             < int * > csrColumnOffsets_v_h.data,
                                             < int * > csrRowIndeces_v_u.data,
                                             < int * > csrColumnOffsets_v_u.data,
                                             < int * > csrRowIndeces_v_v.data,
                                             < int * > csrColumnOffsets_v_v.data,
                                             < double * > globalJacobian_a.data,
                                             nExteriorElementBoundaries_global,
                                             < int * > exteriorElementBoundariesArray.data,
                                             < int * > elementBoundaryElementsArray.data,
                                             < int * > elementBoundaryLocalElementBoundariesArray.data,
                                             < int * > isDOFBoundary_h.data,
                                             < int * > isDOFBoundary_u.data,
                                             < int * > isDOFBoundary_v.data,
                                             < int * > isAdvectiveFluxBoundary_h.data,
                                             < int * > isAdvectiveFluxBoundary_u.data,
                                             < int * > isAdvectiveFluxBoundary_v.data,
                                             < int * > isDiffusiveFluxBoundary_u.data,
                                             < int * > isDiffusiveFluxBoundary_v.data,
                                             < double * > ebqe_bc_h_ext.data,
                                             < double * > ebqe_bc_flux_mass_ext.data,
                                             < double * > ebqe_bc_flux_mom_u_adv_ext.data,
                                             < double * > ebqe_bc_flux_mom_v_adv_ext.data,
                                             < double * > ebqe_bc_u_ext.data,
                                             < double * > ebqe_bc_flux_u_diff_ext.data,
                                             < double * > ebqe_henalty_ext.data,
                                             < double * > ebqe_bc_v_ext.data,
                                             < double * > ebqe_bc_flux_v_diff_ext.data,
                                             < int * > csrColumnOffsets_eb_h_h.data,
                                             < int * > csrColumnOffsets_eb_h_u.data,
                                             < int * > csrColumnOffsets_eb_h_v.data,
                                             < int * > csrColumnOffsets_eb_u_h.data,
                                             < int * > csrColumnOffsets_eb_u_u.data,
                                             < int * > csrColumnOffsets_eb_u_v.data,
                                             < int * > csrColumnOffsets_eb_v_h.data,
                                             < int * > csrColumnOffsets_eb_v_u.data,
                                             < int * > csrColumnOffsets_eb_v_v.data)
