# A type of -*- python -*- file
import numpy
cimport numpy
from proteus import *
from proteus.Transport import *
from proteus.Transport import OneLevelTransport

cdef extern from "VOF.h" namespace "proteus":
    cdef cppclass VOF_base:
        void calculateResidual(double dt,
                               double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * u_trial_ref,
                               double * u_grad_trial_ref,
                               double * u_test_ref,
                               double * u_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * u_trial_trace_ref,
                               double * u_grad_trial_trace_ref,
                               double * u_test_trace_ref,
                               double * u_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               int nElements_global,
                               double useMetrics,
                               double alphaBDF,
                               int lag_shockCapturing,
                               double shockCapturingDiffusion,
                               double sc_uref, double sc_alpha,
                               double * q_porosity,
                               double * porosity_dof,
                               int * u_l2g,
                               int * r_l2g,
                               double * elementDiameter,
                               int degree_polynomial,
                               double * u_dof,
                               double * u_dof_old,
                               double * velocity,
                               double * q_m,
                               double * q_u,
                               double * q_m_betaBDF,
                               double * q_dV,
                               double * q_dV_last,
                               double * cfl,
                               double * edge_based_cfl,
                               double * q_numDiff_u,
                               double * q_numDiff_u_last,
                               int offset_u, int stride_u,
                               double * globalResidual,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_velocity_ext,
                               double * ebqe_porosity_ext,
                               int * isDOFBoundary_u,
                               double * ebqe_bc_u_ext,
                               int * isFluxBoundary_u,
                               double * ebqe_bc_flux_u_ext,
                               double * ebqe_phi, double epsFact,
                               double * ebqe_u,
                               double * ebqe_flux,
                               double cE,
                               double cK,
                               double uL,
                               double uR,
                               int numDOFs,
                               int NNZ,
                               int * csrRowIndeces_DofLoops,
                               int * csrColumnOffsets_DofLoops,
                               int * csrRowIndeces_CellLoops,
                               int * csrColumnOffsets_CellLoops,
                               int * csrColumnOffsets_eb_CellLoops,
                               double * Cx,
                               double * Cy,
                               double * Cz,
                               double * CTx,
                               double * CTy,
                               double * CTz,
                               double * ML,
                               int LUMPED_MASS_MATRIX,
                               int STABILIZATION_TYPE,
                               int ENTROPY_TYPE,
                               double * low_order_solution,
                               double * dL_minus_dC,
                               double * min_u_bc,
                               double * max_u_bc,
                               double * quantDOFs)
        void calculateJacobian(double dt,
                               double * mesh_trial_ref,
                               double * mesh_grad_trial_ref,
                               double * mesh_dof,
                               double * mesh_velocity_dof,
                               double MOVING_DOMAIN,
                               int * mesh_l2g,
                               double * dV_ref,
                               double * u_trial_ref,
                               double * u_grad_trial_ref,
                               double * u_test_ref,
                               double * u_grad_test_ref,
                               double * mesh_trial_trace_ref,
                               double * mesh_grad_trial_trace_ref,
                               double * dS_ref,
                               double * u_trial_trace_ref,
                               double * u_grad_trial_trace_ref,
                               double * u_test_trace_ref,
                               double * u_grad_test_trace_ref,
                               double * normal_ref,
                               double * boundaryJac_ref,
                               int nElements_global,
                               double useMetrics,
                               double alphaBDF,
                               int lag_shockCapturing,
                               double shockCapturingDiffusion,
                               double * q_porosity,
                               int * u_l2g,
                               int * r_l2g,
                               double * elementDiameter,
                               int degree_polynomial,
                               double * u_dof,
                               double * velocity,
                               double * q_m_betaBDF,
                               double * cfl,
                               double * q_numDiff_u_last,
                               int * csrRowIndeces_u_u, int * csrColumnOffsets_u_u,
                               double * globalJacobian,
                               int nExteriorElementBoundaries_global,
                               int * exteriorElementBoundariesArray,
                               int * elementBoundaryElementsArray,
                               int * elementBoundaryLocalElementBoundariesArray,
                               double * ebqe_velocity_ext,
                               double * ebqe_porosity_ext,
                               int * isDOFBoundary_u,
                               double * ebqe_bc_u_ext,
                               int * isFluxBoundary_u,
                               double * ebqe_bc_flux_u_ext,
                               int * csrColumnOffsets_eb_u_u,
                               int LUMPED_MASS_MATRIX)
        void FCTStep(int NNZ,
                     int numDOFs,
                     double * lumped_mass_matrix,
                     double * soln,
                     double * solH,
                     double * low_order_solution,
                     double * limited_solution,
                     int * csrRowIndeces_DofLoops,
                     int * csrColumnOffsets_DofLoops,
                     double * MassMatrix,
                     double * dL_minus_dC,
                     double * min_u_bc,
                     double * max_u_bc,
                     int LUMPED_MASS_MATRIX)
        void calculateResidual_entropy_viscosity(double dt,
                                                 double * mesh_trial_ref,
                                                 double * mesh_grad_trial_ref,
                                                 double * mesh_dof,
                                                 double * mesh_velocity_dof,
                                                 double MOVING_DOMAIN,
                                                 int * mesh_l2g,
                                                 double * dV_ref,
                                                 double * u_trial_ref,
                                                 double * u_grad_trial_ref,
                                                 double * u_test_ref,
                                                 double * u_grad_test_ref,
                                                 double * mesh_trial_trace_ref,
                                                 double * mesh_grad_trial_trace_ref,
                                                 double * dS_ref,
                                                 double * u_trial_trace_ref,
                                                 double * u_grad_trial_trace_ref,
                                                 double * u_test_trace_ref,
                                                 double * u_grad_test_trace_ref,
                                                 double * normal_ref,
                                                 double * boundaryJac_ref,
                                                 int nElements_global,
                                                 double useMetrics,
                                                 double alphaBDF,
                                                 int lag_shockCapturing,
                                                 double shockCapturingDiffusion,
                                                 double sc_uref, double sc_alpha,
                                                 double * q_porosity,
                                                 double * porosity_dof,
                                                 int * u_l2g,
                                                 int * r_l2g,
                                                 double * elementDiameter,
                                                 int degree_polynomial,
                                                 double * u_dof,
                                                 double * u_dof_old,
                                                 double * velocity,
                                                 double * q_m,
                                                 double * q_u,
                                                 double * q_m_betaBDF,
                                                 double * q_dV,
                                                 double * q_dV_last,
                                                 double * cfl,
                                                 double * edge_based_cfl,
                                                 double * q_numDiff_u,
                                                 double * q_numDiff_u_last,
                                                 int offset_u, int stride_u,
                                                 double * globalResidual,
                                                 int nExteriorElementBoundaries_global,
                                                 int * exteriorElementBoundariesArray,
                                                 int * elementBoundaryElementsArray,
                                                 int * elementBoundaryLocalElementBoundariesArray,
                                                 double * ebqe_velocity_ext,
                                                 double * ebqe_porosity_ext,
                                                 int * isDOFBoundary_u,
                                                 double * ebqe_bc_u_ext,
                                                 int * isFluxBoundary_u,
                                                 double * ebqe_bc_flux_u_ext,
                                                 double * ebqe_phi, double epsFact,
                                                 double * ebqe_u,
                                                 double * ebqe_flux,
                                                 double cE,
                                                 double cK,
                                                 double uL,
                                                 double uR,
                                                 int numDOFs,
                                                 int NNZ,
                                                 int * csrRowIndeces_DofLoops,
                                                 int * csrColumnOffsets_DofLoops,
                                                 int * csrRowIndeces_CellLoops,
                                                 int * csrColumnOffsets_CellLoops,
                                                 int * csrColumnOffsets_eb_CellLoops,
                                                 double * Cx,
                                                 double * Cy,
                                                 double * Cz,
                                                 double * CTx,
                                                 double * CTy,
                                                 double * CTz,
                                                 double * ML,
                                                 int LUMPED_MASS_MATRIX,
                                                 int STABILIZATION_TYPE,
                                                 int ENTROPY_TYPE,
                                                 double * low_order_solution,
                                                 double * dL_minus_dC,
                                                 double * min_u_bc,
                                                 double * max_u_bc,
                                                 double * quantDOFs)
        void calculateMassMatrix(double dt,
                                 double * mesh_trial_ref,
                                 double * mesh_grad_trial_ref,
                                 double * mesh_dof,
                                 double * mesh_velocity_dof,
                                 double MOVING_DOMAIN,
                                 int * mesh_l2g,
                                 double * dV_ref,
                                 double * u_trial_ref,
                                 double * u_grad_trial_ref,
                                 double * u_test_ref,
                                 double * u_grad_test_ref,
                                 double * mesh_trial_trace_ref,
                                 double * mesh_grad_trial_trace_ref,
                                 double * dS_ref,
                                 double * u_trial_trace_ref,
                                 double * u_grad_trial_trace_ref,
                                 double * u_test_trace_ref,
                                 double * u_grad_test_trace_ref,
                                 double * normal_ref,
                                 double * boundaryJac_ref,
                                 int nElements_global,
                                 double useMetrics,
                                 double alphaBDF,
                                 int lag_shockCapturing,
                                 double shockCapturingDiffusion,
                                 double * q_porosity,
                                 int * u_l2g,
                                 int * r_l2g,
                                 double * elementDiameter,
                                 int degree_polynomial,
                                 double * u_dof,
                                 double * velocity,
                                 double * q_m_betaBDF,
                                 double * cfl,
                                 double * q_numDiff_u_last,
                                 int * csrRowIndeces_u_u, int * csrColumnOffsets_u_u,
                                 double * globalJacobian,
                                 int nExteriorElementBoundaries_global,
                                 int * exteriorElementBoundariesArray,
                                 int * elementBoundaryElementsArray,
                                 int * elementBoundaryLocalElementBoundariesArray,
                                 double * ebqe_velocity_ext,
                                 double * ebqe_porosity_ext,
                                 int * isDOFBoundary_u,
                                 double * ebqe_bc_u_ext,
                                 int * isFluxBoundary_u,
                                 double * ebqe_bc_flux_u_ext,
                                 int * csrColumnOffsets_eb_u_u,
                                 int LUMPED_MASS_MATRIX)
    VOF_base * newVOF(int nSpaceIn,
                      int nQuadraturePoints_elementIn,
                      int nDOF_mesh_trial_elementIn,
                      int nDOF_trial_elementIn,
                      int nDOF_test_elementIn,
                      int nQuadraturePoints_elementBoundaryIn,
                      int CompKernelFlag)

cdef class cVOF_base:
    cdef VOF_base * thisptr

    def __cinit__(self,
                  int nSpaceIn,
                  int nQuadraturePoints_elementIn,
                  int nDOF_mesh_trial_elementIn,
                  int nDOF_trial_elementIn,
                  int nDOF_test_elementIn,
                  int nQuadraturePoints_elementBoundaryIn,
                  int CompKernelFlag):
        self.thisptr = newVOF(nSpaceIn,
                              nQuadraturePoints_elementIn,
                              nDOF_mesh_trial_elementIn,
                              nDOF_trial_elementIn,
                              nDOF_test_elementIn,
                              nQuadraturePoints_elementBoundaryIn,
                              CompKernelFlag)

    def __dealloc__(self):
        del self.thisptr

    def calculateResidual(self,
                          double dt,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray u_trial_ref,
                          numpy.ndarray u_grad_trial_ref,
                          numpy.ndarray u_test_ref,
                          numpy.ndarray u_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray u_trial_trace_ref,
                          numpy.ndarray u_grad_trial_trace_ref,
                          numpy.ndarray u_test_trace_ref,
                          numpy.ndarray u_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          int nElements_global,
                          double useMetrics,
                          double alphaBDF,
                          int lag_shockCapturing,
                          double shockCapturingDiffusion,
                          double sc_uref, double sc_alpha,
                          numpy.ndarray q_porosity,
                          numpy.ndarray porosity_dof,
                          numpy.ndarray u_l2g,
                          numpy.ndarray r_l2g,
                          numpy.ndarray elementDiameter,
                          int degree_polynomial,
                          numpy.ndarray u_dof,
                          numpy.ndarray u_dof_old,
                          numpy.ndarray velocity,
                          numpy.ndarray q_m,
                          numpy.ndarray q_u,
                          numpy.ndarray q_m_betaBDF,
                          numpy.ndarray q_dV,
                          numpy.ndarray q_dV_last,
                          numpy.ndarray cfl,
                          numpy.ndarray edge_based_cfl,
                          numpy.ndarray q_numDiff_u,
                          numpy.ndarray q_numDiff_u_last,
                          int offset_u, int stride_u,
                          numpy.ndarray globalResidual,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_velocity_ext,
                          numpy.ndarray ebqe_porosity_ext,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray isFluxBoundary_u,
                          numpy.ndarray ebqe_bc_flux_u_ext,
                          numpy.ndarray ebqe_phi, double epsFact,
                          numpy.ndarray ebqe_u,
                          numpy.ndarray ebqe_flux,
                          double cE,
                          double cK,
                          double uL,
                          double uR,
                          int numDOFs,
                          int NNZ,
                          numpy.ndarray csrRowIndeces_DofLoops,
                          numpy.ndarray csrColumnOffsets_DofLoops,
                          numpy.ndarray csrRowIndeces_CellLoops,
                          numpy.ndarray csrColumnOffsets_CellLoops,
                          numpy.ndarray csrColumnOffsets_eb_CellLoops,
                          numpy.ndarray Cx,
                          numpy.ndarray Cy,
                          numpy.ndarray Cz,
                          numpy.ndarray CTx,
                          numpy.ndarray CTy,
                          numpy.ndarray CTz,
                          numpy.ndarray ML,
                          int LUMPED_MASS_MATRIX,
                          int STABILIZATION_TYPE,
                          int ENTROPY_TYPE,
                          numpy.ndarray low_order_solution,
                          numpy.ndarray dt_times_dH_minus_dL,
                          numpy.ndarray min_u_bc,
                          numpy.ndarray max_u_bc,
                          numpy.ndarray quantDOFs):
        self.thisptr.calculateResidual(dt,
                                       < double * > mesh_trial_ref.data,
                                       < double * > mesh_grad_trial_ref.data,
                                       < double * > mesh_dof.data,
                                       < double * > mesh_velocity_dof.data,
                                       MOVING_DOMAIN,
                                       < int * > mesh_l2g.data,
                                       < double * > dV_ref.data,
                                       < double * > u_trial_ref.data,
                                       < double * > u_grad_trial_ref.data,
                                       < double * > u_test_ref.data,
                                       < double * > u_grad_test_ref.data,
                                       < double * > mesh_trial_trace_ref.data,
                                       < double * > mesh_grad_trial_trace_ref.data,
                                       < double * > dS_ref.data,
                                       < double * > u_trial_trace_ref.data,
                                       < double * > u_grad_trial_trace_ref.data,
                                       < double * > u_test_trace_ref.data,
                                       < double * > u_grad_test_trace_ref.data,
                                       < double * > normal_ref.data,
                                       < double * > boundaryJac_ref.data,
                                       nElements_global,
                                       useMetrics,
                                       alphaBDF,
                                       lag_shockCapturing,
                                       shockCapturingDiffusion,
                                       sc_uref, sc_alpha,
                                       < double * > q_porosity.data,
                                       < double * > porosity_dof.data,
                                       < int * > u_l2g.data,
                                       < int * > r_l2g.data,
                                       < double * > elementDiameter.data,
                                       degree_polynomial,
                                       < double * > u_dof.data,
                                       < double * > u_dof_old.data,
                                       < double * > velocity.data,
                                       < double * > q_m.data,
                                       < double * > q_u.data,
                                       < double * > q_m_betaBDF.data,
                                       < double * > q_dV.data,
                                       < double * > q_dV_last.data,
                                       < double * > cfl.data,
                                       < double * > edge_based_cfl.data,
                                       < double * > q_numDiff_u.data,
                                       < double * > q_numDiff_u_last.data,
                                       offset_u, stride_u,
                                       < double * > globalResidual.data,
                                       nExteriorElementBoundaries_global,
                                       < int * > exteriorElementBoundariesArray.data,
                                       < int * > elementBoundaryElementsArray.data,
                                       < int * > elementBoundaryLocalElementBoundariesArray.data,
                                       < double * > ebqe_velocity_ext.data,
                                       < double * > ebqe_porosity_ext.data,
                                       < int * > isDOFBoundary_u.data,
                                       < double * > ebqe_bc_u_ext.data,
                                       < int * > isFluxBoundary_u.data,
                                       < double * > ebqe_bc_flux_u_ext.data,
                                       < double * > ebqe_phi.data,
                                       epsFact,
                                       < double * > ebqe_u.data,
                                       < double * > ebqe_flux.data,
                                       cE,
                                       cK,
                                       uL,
                                       uR,
                                       numDOFs,
                                       NNZ,
                                       < int * > csrRowIndeces_DofLoops.data,
                                       < int * > csrColumnOffsets_DofLoops.data,
                                       < int * > csrRowIndeces_CellLoops.data,
                                       < int * > csrColumnOffsets_CellLoops.data,
                                       < int * > csrColumnOffsets_eb_CellLoops.data,
                                       < double * > Cx.data,
                                       < double * > Cy.data,
                                       < double * > Cz.data,
                                       < double * > CTx.data,
                                       < double * > CTy.data,
                                       < double * > CTz.data,
                                       < double * > ML.data,
                                       LUMPED_MASS_MATRIX,
                                       STABILIZATION_TYPE,
                                       ENTROPY_TYPE,
                                       < double * > low_order_solution.data,
                                       < double * > dt_times_dH_minus_dL.data,
                                       < double * > min_u_bc.data,
                                       < double * > max_u_bc.data,
                                       < double * > quantDOFs.data)

    def calculateJacobian(self,
                          double dt,
                          numpy.ndarray mesh_trial_ref,
                          numpy.ndarray mesh_grad_trial_ref,
                          numpy.ndarray mesh_dof,
                          numpy.ndarray mesh_velocity_dof,
                          double MOVING_DOMAIN,
                          numpy.ndarray mesh_l2g,
                          numpy.ndarray dV_ref,
                          numpy.ndarray u_trial_ref,
                          numpy.ndarray u_grad_trial_ref,
                          numpy.ndarray u_test_ref,
                          numpy.ndarray u_grad_test_ref,
                          numpy.ndarray mesh_trial_trace_ref,
                          numpy.ndarray mesh_grad_trial_trace_ref,
                          numpy.ndarray dS_ref,
                          numpy.ndarray u_trial_trace_ref,
                          numpy.ndarray u_grad_trial_trace_ref,
                          numpy.ndarray u_test_trace_ref,
                          numpy.ndarray u_grad_test_trace_ref,
                          numpy.ndarray normal_ref,
                          numpy.ndarray boundaryJac_ref,
                          int nElements_global,
                          double useMetrics,
                          double alphaBDF,
                          int lag_shockCapturing,
                          double shockCapturingDiffusion,
                          numpy.ndarray q_porosity,
                          numpy.ndarray u_l2g,
                          numpy.ndarray r_l2g,
                          numpy.ndarray elementDiameter,
                          int degree_polynomial,
                          numpy.ndarray u_dof,
                          numpy.ndarray velocity,
                          numpy.ndarray q_m_betaBDF,
                          numpy.ndarray cfl,
                          numpy.ndarray q_numDiff_u_last,
                          numpy.ndarray csrRowIndeces_u_u, numpy.ndarray csrColumnOffsets_u_u,
                          globalJacobian,
                          int nExteriorElementBoundaries_global,
                          numpy.ndarray exteriorElementBoundariesArray,
                          numpy.ndarray elementBoundaryElementsArray,
                          numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                          numpy.ndarray ebqe_velocity_ext,
                          numpy.ndarray ebqe_porosity_ext,
                          numpy.ndarray isDOFBoundary_u,
                          numpy.ndarray ebqe_bc_u_ext,
                          numpy.ndarray isFluxBoundary_u,
                          numpy.ndarray ebqe_bc_flux_u_ext,
                          numpy.ndarray csrColumnOffsets_eb_u_u,
                          int LUMPED_MASS_MATRIX):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateJacobian(dt,
                                       < double * > mesh_trial_ref.data,
                                       < double * > mesh_grad_trial_ref.data,
                                       < double * > mesh_dof.data,
                                       < double * > mesh_velocity_dof.data,
                                       MOVING_DOMAIN,
                                       < int * > mesh_l2g.data,
                                       < double * > dV_ref.data,
                                       < double * > u_trial_ref.data,
                                       < double * > u_grad_trial_ref.data,
                                       < double * > u_test_ref.data,
                                       < double * > u_grad_test_ref.data,
                                       < double * > mesh_trial_trace_ref.data,
                                       < double * > mesh_grad_trial_trace_ref.data,
                                       < double * > dS_ref.data,
                                       < double * > u_trial_trace_ref.data,
                                       < double * > u_grad_trial_trace_ref.data,
                                       < double * > u_test_trace_ref.data,
                                       < double * > u_grad_test_trace_ref.data,
                                       < double * > normal_ref.data,
                                       < double * > boundaryJac_ref.data,
                                       nElements_global,
                                       useMetrics,
                                       alphaBDF,
                                       lag_shockCapturing,
                                       shockCapturingDiffusion,
                                       < double * > q_porosity.data,
                                       < int * > u_l2g.data,
                                       < int * > r_l2g.data,
                                       < double * > elementDiameter.data,
                                       degree_polynomial,
                                       < double * > u_dof.data,
                                       < double * > velocity.data,
                                       < double * > q_m_betaBDF.data,
                                       < double * > cfl.data,
                                       < double * > q_numDiff_u_last.data,
                                       < int * > csrRowIndeces_u_u.data, < int * > csrColumnOffsets_u_u.data,
                                       < double * > globalJacobian_a.data,
                                       nExteriorElementBoundaries_global,
                                       < int * > exteriorElementBoundariesArray.data,
                                       < int * > elementBoundaryElementsArray.data,
                                       < int * > elementBoundaryLocalElementBoundariesArray.data,
                                       < double * > ebqe_velocity_ext.data,
                                       < double * > ebqe_porosity_ext.data,
                                       < int * > isDOFBoundary_u.data,
                                       < double * > ebqe_bc_u_ext.data,
                                       < int * > isFluxBoundary_u.data,
                                       < double * > ebqe_bc_flux_u_ext.data,
                                       < int * > csrColumnOffsets_eb_u_u.data,
                                       LUMPED_MASS_MATRIX)

    def FCTStep(self,
                int NNZ,
                int numDOFs,
                numpy.ndarray lumped_mass_matrix,
                numpy.ndarray soln,
                numpy.ndarray solH,
                numpy.ndarray low_order_solution,
                numpy.ndarray limited_solution,
                numpy.ndarray csrRowIndeces_DofLoops,
                numpy.ndarray csrColumnOffsets_DofLoops,
                numpy.ndarray MassMatrix,
                numpy.ndarray dt_times_dH_minus_dL,
                numpy.ndarray min_u_bc,
                numpy.ndarray max_u_bc,
                int LUMPED_MASS_MATRIX):
        self.thisptr.FCTStep(NNZ,
                             numDOFs,
                             < double * > lumped_mass_matrix.data,
                             < double * > soln.data,
                             < double * > solH.data,
                             < double * > low_order_solution.data,
                             < double * > limited_solution.data,
                             < int * > csrRowIndeces_DofLoops.data,
                             < int * > csrColumnOffsets_DofLoops.data,
                             < double * > MassMatrix.data,
                             < double * > dt_times_dH_minus_dL.data,
                             < double * > min_u_bc.data,
                             < double * > max_u_bc.data,
                             LUMPED_MASS_MATRIX)

    def calculateResidual_entropy_viscosity(self,
                                            double dt,
                                            numpy.ndarray mesh_trial_ref,
                                            numpy.ndarray mesh_grad_trial_ref,
                                            numpy.ndarray mesh_dof,
                                            numpy.ndarray mesh_velocity_dof,
                                            double MOVING_DOMAIN,
                                            numpy.ndarray mesh_l2g,
                                            numpy.ndarray dV_ref,
                                            numpy.ndarray u_trial_ref,
                                            numpy.ndarray u_grad_trial_ref,
                                            numpy.ndarray u_test_ref,
                                            numpy.ndarray u_grad_test_ref,
                                            numpy.ndarray mesh_trial_trace_ref,
                                            numpy.ndarray mesh_grad_trial_trace_ref,
                                            numpy.ndarray dS_ref,
                                            numpy.ndarray u_trial_trace_ref,
                                            numpy.ndarray u_grad_trial_trace_ref,
                                            numpy.ndarray u_test_trace_ref,
                                            numpy.ndarray u_grad_test_trace_ref,
                                            numpy.ndarray normal_ref,
                                            numpy.ndarray boundaryJac_ref,
                                            int nElements_global,
                                            double useMetrics,
                                            double alphaBDF,
                                            int lag_shockCapturing,
                                            double shockCapturingDiffusion,
                                            double sc_uref, double sc_alpha,
                                            numpy.ndarray q_porosity,
                                            numpy.ndarray porosity_dof,
                                            numpy.ndarray u_l2g,
                                            numpy.ndarray r_l2g,
                                            numpy.ndarray elementDiameter,
                                            int degree_polynomial,
                                            numpy.ndarray u_dof,
                                            numpy.ndarray u_dof_old,
                                            numpy.ndarray velocity,
                                            numpy.ndarray q_m,
                                            numpy.ndarray q_u,
                                            numpy.ndarray q_m_betaBDF,
                                            numpy.ndarray q_dV,
                                            numpy.ndarray q_dV_last,
                                            numpy.ndarray cfl,
                                            numpy.ndarray edge_based_cfl,
                                            numpy.ndarray q_numDiff_u,
                                            numpy.ndarray q_numDiff_u_last,
                                            int offset_u, int stride_u,
                                            numpy.ndarray globalResidual,
                                            int nExteriorElementBoundaries_global,
                                            numpy.ndarray exteriorElementBoundariesArray,
                                            numpy.ndarray elementBoundaryElementsArray,
                                            numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                                            numpy.ndarray ebqe_velocity_ext,
                                            numpy.ndarray ebqe_porosity_ext,
                                            numpy.ndarray isDOFBoundary_u,
                                            numpy.ndarray ebqe_bc_u_ext,
                                            numpy.ndarray isFluxBoundary_u,
                                            numpy.ndarray ebqe_bc_flux_u_ext,
                                            numpy.ndarray ebqe_phi, double epsFact,
                                            numpy.ndarray ebqe_u,
                                            numpy.ndarray ebqe_flux,
                                            double cE,
                                            double cK,
                                            double uL,
                                            double uR,
                                            int numDOFs,
                                            int NNZ,
                                            numpy.ndarray csrRowIndeces_DofLoops,
                                            numpy.ndarray csrColumnOffsets_DofLoops,
                                            numpy.ndarray csrRowIndeces_CellLoops,
                                            numpy.ndarray csrColumnOffsets_CellLoops,
                                            numpy.ndarray csrColumnOffsets_eb_CellLoops,
                                            numpy.ndarray Cx,
                                            numpy.ndarray Cy,
                                            numpy.ndarray Cz,
                                            numpy.ndarray CTx,
                                            numpy.ndarray CTy,
                                            numpy.ndarray CTz,
                                            numpy.ndarray ML,
                                            int LUMPED_MASS_MATRIX,
                                            int STABILIZATION_TYPE,
                                            int ENTROPY_TYPE,
                                            numpy.ndarray low_order_solution,
                                            numpy.ndarray dt_times_dH_minus_dL,
                                            numpy.ndarray min_u_bc,
                                            numpy.ndarray max_u_bc,
                                            numpy.ndarray quantDOFs):
        self.thisptr.calculateResidual_entropy_viscosity(dt,
                                                         < double * > mesh_trial_ref.data,
                                                         < double * > mesh_grad_trial_ref.data,
                                                         < double * > mesh_dof.data,
                                                         < double * > mesh_velocity_dof.data,
                                                         MOVING_DOMAIN,
                                                         < int * > mesh_l2g.data,
                                                         < double * > dV_ref.data,
                                                         < double * > u_trial_ref.data,
                                                         < double * > u_grad_trial_ref.data,
                                                         < double * > u_test_ref.data,
                                                         < double * > u_grad_test_ref.data,
                                                         < double * > mesh_trial_trace_ref.data,
                                                         < double * > mesh_grad_trial_trace_ref.data,
                                                         < double * > dS_ref.data,
                                                         < double * > u_trial_trace_ref.data,
                                                         < double * > u_grad_trial_trace_ref.data,
                                                         < double * > u_test_trace_ref.data,
                                                         < double * > u_grad_test_trace_ref.data,
                                                         < double * > normal_ref.data,
                                                         < double * > boundaryJac_ref.data,
                                                         nElements_global,
                                                         useMetrics,
                                                         alphaBDF,
                                                         lag_shockCapturing,
                                                         shockCapturingDiffusion,
                                                         sc_uref, sc_alpha,
                                                         < double * > q_porosity.data,
                                                         < double * > porosity_dof.data,
                                                         < int * > u_l2g.data,
                                                         < int * > r_l2g.data,
                                                         < double * > elementDiameter.data,
                                                         degree_polynomial,
                                                         < double * > u_dof.data,
                                                         < double * > u_dof_old.data,
                                                         < double * > velocity.data,
                                                         < double * > q_m.data,
                                                         < double * > q_u.data,
                                                         < double * > q_m_betaBDF.data,
                                                         < double * > q_dV.data,
                                                         < double * > q_dV_last.data,
                                                         < double * > cfl.data,
                                                         < double * > edge_based_cfl.data,
                                                         < double * > q_numDiff_u.data,
                                                         < double * > q_numDiff_u_last.data,
                                                         offset_u, stride_u,
                                                         < double * > globalResidual.data,
                                                         nExteriorElementBoundaries_global,
                                                         < int * > exteriorElementBoundariesArray.data,
                                                         < int * > elementBoundaryElementsArray.data,
                                                         < int * > elementBoundaryLocalElementBoundariesArray.data,
                                                         < double * > ebqe_velocity_ext.data,
                                                         < double * > ebqe_porosity_ext.data,
                                                         < int * > isDOFBoundary_u.data,
                                                         < double * > ebqe_bc_u_ext.data,
                                                         < int * > isFluxBoundary_u.data,
                                                         < double * > ebqe_bc_flux_u_ext.data,
                                                         < double * > ebqe_phi.data,
                                                         epsFact,
                                                         < double * > ebqe_u.data,
                                                         < double * > ebqe_flux.data,
                                                         cE,
                                                         cK,
                                                         uL,
                                                         uR,
                                                         numDOFs,
                                                         NNZ,
                                                         < int * > csrRowIndeces_DofLoops.data,
                                                         < int * > csrColumnOffsets_DofLoops.data,
                                                         < int * > csrRowIndeces_CellLoops.data,
                                                         < int * > csrColumnOffsets_CellLoops.data,
                                                         < int * > csrColumnOffsets_eb_CellLoops.data,
                                                         < double * > Cx.data,
                                                         < double * > Cy.data,
                                                         < double * > Cz.data,
                                                         < double * > CTx.data,
                                                         < double * > CTy.data,
                                                         < double * > CTz.data,
                                                         < double * > ML.data,
                                                         LUMPED_MASS_MATRIX,
                                                         STABILIZATION_TYPE,
                                                         ENTROPY_TYPE,
                                                         < double * > low_order_solution.data,
                                                         < double * > dt_times_dH_minus_dL.data,
                                                         < double * > min_u_bc.data,
                                                         < double * > max_u_bc.data,
                                                         < double * > quantDOFs.data)

    def calculateMassMatrix(self,
                            double dt,
                            numpy.ndarray mesh_trial_ref,
                            numpy.ndarray mesh_grad_trial_ref,
                            numpy.ndarray mesh_dof,
                            numpy.ndarray mesh_velocity_dof,
                            double MOVING_DOMAIN,
                            numpy.ndarray mesh_l2g,
                            numpy.ndarray dV_ref,
                            numpy.ndarray u_trial_ref,
                            numpy.ndarray u_grad_trial_ref,
                            numpy.ndarray u_test_ref,
                            numpy.ndarray u_grad_test_ref,
                            numpy.ndarray mesh_trial_trace_ref,
                            numpy.ndarray mesh_grad_trial_trace_ref,
                            numpy.ndarray dS_ref,
                            numpy.ndarray u_trial_trace_ref,
                            numpy.ndarray u_grad_trial_trace_ref,
                            numpy.ndarray u_test_trace_ref,
                            numpy.ndarray u_grad_test_trace_ref,
                            numpy.ndarray normal_ref,
                            numpy.ndarray boundaryJac_ref,
                            int nElements_global,
                            double useMetrics,
                            double alphaBDF,
                            int lag_shockCapturing,
                            double shockCapturingDiffusion,
                            numpy.ndarray q_porosity,
                            numpy.ndarray u_l2g,
                            numpy.ndarray r_l2g,
                            numpy.ndarray elementDiameter,
                            int degree_polynomial,
                            numpy.ndarray u_dof,
                            numpy.ndarray velocity,
                            numpy.ndarray q_m_betaBDF,
                            numpy.ndarray cfl,
                            numpy.ndarray q_numDiff_u_last,
                            numpy.ndarray csrRowIndeces_u_u, numpy.ndarray csrColumnOffsets_u_u,
                            globalJacobian,
                            int nExteriorElementBoundaries_global,
                            numpy.ndarray exteriorElementBoundariesArray,
                            numpy.ndarray elementBoundaryElementsArray,
                            numpy.ndarray elementBoundaryLocalElementBoundariesArray,
                            numpy.ndarray ebqe_velocity_ext,
                            numpy.ndarray ebqe_porosity_ext,
                            numpy.ndarray isDOFBoundary_u,
                            numpy.ndarray ebqe_bc_u_ext,
                            numpy.ndarray isFluxBoundary_u,
                            numpy.ndarray ebqe_bc_flux_u_ext,
                            numpy.ndarray csrColumnOffsets_eb_u_u,
                            int LUMPED_MASS_MATRIX):
        cdef numpy.ndarray rowptr, colind, globalJacobian_a
        (rowptr, colind, globalJacobian_a) = globalJacobian.getCSRrepresentation()
        self.thisptr.calculateMassMatrix(dt,
                                         < double * > mesh_trial_ref.data,
                                         < double * > mesh_grad_trial_ref.data,
                                         < double * > mesh_dof.data,
                                         < double * > mesh_velocity_dof.data,
                                         MOVING_DOMAIN,
                                         < int * > mesh_l2g.data,
                                         < double * > dV_ref.data,
                                         < double * > u_trial_ref.data,
                                         < double * > u_grad_trial_ref.data,
                                         < double * > u_test_ref.data,
                                         < double * > u_grad_test_ref.data,
                                         < double * > mesh_trial_trace_ref.data,
                                         < double * > mesh_grad_trial_trace_ref.data,
                                         < double * > dS_ref.data,
                                         < double * > u_trial_trace_ref.data,
                                         < double * > u_grad_trial_trace_ref.data,
                                         < double * > u_test_trace_ref.data,
                                         < double * > u_grad_test_trace_ref.data,
                                         < double * > normal_ref.data,
                                         < double * > boundaryJac_ref.data,
                                         nElements_global,
                                         useMetrics,
                                         alphaBDF,
                                         lag_shockCapturing,
                                         shockCapturingDiffusion,
                                         < double * > q_porosity.data,
                                         < int * > u_l2g.data,
                                         < int * > r_l2g.data,
                                         < double * > elementDiameter.data,
                                         degree_polynomial,
                                         < double * > u_dof.data,
                                         < double * > velocity.data,
                                         < double * > q_m_betaBDF.data,
                                         < double * > cfl.data,
                                         < double * > q_numDiff_u_last.data,
                                         < int * > csrRowIndeces_u_u.data, < int * > csrColumnOffsets_u_u.data,
                                         < double * > globalJacobian_a.data,
                                         nExteriorElementBoundaries_global,
                                         < int * > exteriorElementBoundariesArray.data,
                                         < int * > elementBoundaryElementsArray.data,
                                         < int * > elementBoundaryLocalElementBoundariesArray.data,
                                         < double * > ebqe_velocity_ext.data,
                                         < double * > ebqe_porosity_ext.data,
                                         < int * > isDOFBoundary_u.data,
                                         < double * > ebqe_bc_u_ext.data,
                                         < int * > isFluxBoundary_u.data,
                                         < double * > ebqe_bc_flux_u_ext.data,
                                         < int * > csrColumnOffsets_eb_u_u.data,
                                         LUMPED_MASS_MATRIX)
